VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   Caption         =   "VBC Media Player"
   ClientHeight    =   6840
   ClientLeft      =   225
   ClientTop       =   855
   ClientWidth     =   12390
   LinkTopic       =   "Form1"
   ScaleHeight     =   456
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   826
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdMute 
      Height          =   750
      Left            =   11580
      MaskColor       =   &H00FF00FF&
      Style           =   1  'Graphical
      TabIndex        =   7
      Top             =   6060
      UseMaskColor    =   -1  'True
      Width           =   750
   End
   Begin VB.CommandButton cmdStop 
      Height          =   750
      Left            =   1620
      MaskColor       =   &H00FF00FF&
      Style           =   1  'Graphical
      TabIndex        =   6
      Top             =   6030
      UseMaskColor    =   -1  'True
      Width           =   750
   End
   Begin VB.CommandButton cmdPause 
      Height          =   750
      Left            =   840
      MaskColor       =   &H00FF00FF&
      Style           =   1  'Graphical
      TabIndex        =   5
      Top             =   6030
      UseMaskColor    =   -1  'True
      Width           =   750
   End
   Begin VB.CommandButton cmdPlay 
      Height          =   750
      Left            =   60
      MaskColor       =   &H00FF00FF&
      Style           =   1  'Graphical
      TabIndex        =   4
      Top             =   6030
      UseMaskColor    =   -1  'True
      Width           =   750
   End
   Begin VB.PictureBox picSeek 
      Appearance      =   0  'Flat
      BackColor       =   &H000000FF&
      ForeColor       =   &H80000008&
      Height          =   120
      Left            =   840
      ScaleHeight     =   6
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   265
      TabIndex        =   3
      Top             =   5790
      Width           =   4005
   End
   Begin MSComDlg.CommonDialog cdMedia 
      Left            =   8550
      Top             =   60
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.PictureBox picMedia 
      Appearance      =   0  'Flat
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   2955
      Left            =   9090
      ScaleHeight     =   197
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   221
      TabIndex        =   0
      Top             =   0
      Width           =   3315
   End
   Begin VB.PictureBox picVolume 
      Appearance      =   0  'Flat
      BackColor       =   &H00808080&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   525
      Left            =   10020
      ScaleHeight     =   35
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   100
      TabIndex        =   8
      Top             =   6180
      Width           =   1500
   End
   Begin VB.Label lblVolume 
      Caption         =   "100%"
      Height          =   195
      Left            =   10020
      TabIndex        =   9
      Top             =   5970
      Width           =   405
   End
   Begin VB.Label lblCurPosition 
      Caption         =   "00:00:00"
      Height          =   195
      Left            =   120
      TabIndex        =   2
      Top             =   5760
      Width           =   645
   End
   Begin VB.Label lblDuration 
      Caption         =   "00:00:00"
      Height          =   195
      Left            =   4890
      TabIndex        =   1
      Top             =   5760
      Width           =   645
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open"
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileBar1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileProperties 
         Caption         =   "Propert&ies"
      End
      Begin VB.Menu mnuFileBar3 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const ALTERNATE As Long = 1 ' Alternative zwischen gefllt und ungefllt
Private Const WINDING As Long = 2 ' Das Dreieck normal gefllt

Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Declare Function CreatePolygonRgn Lib "gdi32.dll" ( _
                         ByVal lpPoint As Long, _
                         ByVal nCount As Long, _
                         ByVal nPolyFillMode As Long) As Long

Private Declare Function SetWindowRgn Lib "user32.dll" ( _
                         ByVal hWnd As Long, _
                         ByVal hRgn As Long, _
                         ByVal bRedraw As Boolean) As Long

Private Declare Function CreateRoundRectRgn Lib "gdi32.dll" ( _
                         ByVal X1 As Long, _
                         ByVal Y1 As Long, _
                         ByVal X2 As Long, _
                         ByVal Y2 As Long, _
                         ByVal X3 As Long, _
                         ByVal Y3 As Long) As Long

Private Declare Function DeleteObject Lib "gdi32" ( _
                         ByVal hObject As Long) As Long

Private cPlayer As clsMFPlayer
Private WithEvents cTimer As clsMMTimer
Attribute cTimer.VB_VarHelpID = -1

Private Sub cmdMute_Click()

    Dim bolMute As Boolean

    If cPlayer.HasAudio = True Then
    
        If cPlayer.IsAudioVolumeSupport = True Then
        
            If cPlayer.SetAudioMasterMute(Not cPlayer.GetAudioMasterMute) = True Then
            
            End If
        
        End If
        
    End If

End Sub

Private Sub cmdPause_Click()

    If cPlayer.IsInit = True Then

        If cPlayer.IsMediaReady Then
        
            If cPlayer.PauseMedia = True Then
            
            End If
        
        End If
        
    End If

End Sub

Private Sub cmdPlay_Click()

    If cPlayer.IsInit = True Then

        If cPlayer.IsMediaReady Then
        
            If cPlayer.PlayMedia = True Then
            
            End If
        
        End If
        
    End If

End Sub

Private Sub cmdStop_Click()

    If cPlayer.IsInit = True Then

        If cPlayer.IsMediaReady Then
        
            If cPlayer.StopMedia = True Then
            
            End If
        
        End If
        
    End If

End Sub

Private Sub cTimer_Timer()

    Dim bolMute As Boolean
    Dim curDuration As Currency
    Dim curPosition As Currency

    If cPlayer.IsInit = True Then

        If cPlayer.IsMediaReady Then

            curDuration = cPlayer.GetMediaDuration
            curPosition = cPlayer.GetMediaCurrentPosition

            picSeek.Cls
            picSeek.Scale (0, 0)-(curDuration, 1)
            picSeek.Line (0, 0)-(curPosition, 1), vbGreen, BF

            lblDuration.Caption = cPlayer.Time2String(curDuration)
            lblCurPosition.Caption = cPlayer.Time2String(curPosition)

            Select Case cPlayer.GetCurrentState

            Case MFCLOCK_STATE.MFCLOCK_STATE_INVALID

                If cmdPlay.Enabled = True Then cmdPlay.Enabled = False
                If cmdPause.Enabled = False Then cmdPause.Enabled = True
                If cmdStop.Enabled = False Then cmdStop.Enabled = True

                Call cPlayer.PlayMedia

            Case MFCLOCK_STATE.MFCLOCK_STATE_PAUSED

                If cmdPlay.Enabled = False Then cmdPlay.Enabled = True
                If cmdPause.Enabled = True Then cmdPause.Enabled = False
                If cmdStop.Enabled = False Then cmdStop.Enabled = True

            Case MFCLOCK_STATE.MFCLOCK_STATE_RUNNING

                If cmdPlay.Enabled = True Then cmdPlay.Enabled = False
                If cmdPause.Enabled = False Then cmdPause.Enabled = True
                If cmdStop.Enabled = False Then cmdStop.Enabled = True

            Case MFCLOCK_STATE.MFCLOCK_STATE_STOPPED

                If cmdPlay.Enabled = False Then cmdPlay.Enabled = True
                If cmdPause.Enabled = True Then cmdPause.Enabled = False
                If cmdStop.Enabled = True Then cmdStop.Enabled = False

            End Select

            If cPlayer.HasAudio = True Then
                If cPlayer.IsAudioVolumeSupport = True Then
                    
                    If cPlayer.GetAudioMasterMute = False Then
                        
                        If cmdMute.Enabled = False Then
                            cmdMute.Enabled = True
                        End If
                        
                        cmdMute.Picture = LoadResPicture(109, vbResBitmap)
                        cmdMute.DisabledPicture = LoadResPicture(110, vbResBitmap)

                    Else
                        
                        cmdMute.Picture = LoadResPicture(107, vbResBitmap)
                        cmdMute.DisabledPicture = LoadResPicture(108, vbResBitmap)
                        
                    End If
                    
                    picVolume.Cls
                    picVolume.Line (0, 0)-(cPlayer.GetAudioMasterVolume * 100, 1), vbGreen, BF
                    lblVolume.Caption = CStr(cPlayer.GetAudioMasterVolume * 100) & "%"
                End If
                
            End If

        Else

            lblDuration.Caption = "00:00:00"
            lblCurPosition.Caption = "00:00:00"
            lblVolume.Caption = "100%"

            If cmdPlay.Enabled = True Then cmdPlay.Enabled = False
            If cmdPause.Enabled = True Then cmdPause.Enabled = False
            If cmdStop.Enabled = True Then cmdStop.Enabled = False
            If cmdMute.Enabled = True Then cmdMute.Enabled = False

        End If

    End If

End Sub

Private Sub Form_Load()
    
    Dim RWin As SIZEPAR
    Set cTimer = New clsMMTimer
    Set cPlayer = New clsMFPlayer
    
    Call CreateRoundRectButton(cmdPlay, 101, 102)
    Call CreateRoundRectButton(cmdPause, 103, 104)
    Call CreateRoundRectButton(cmdStop, 105, 106)
    Call CreateRoundRectButton(cmdMute, 109, 110)
    Call CreateVolumeCtrl(picVolume)
    
    
    With RWin
        .xMin = 420 'min. Width
        .yMin = 124 'min. Height
        .xMax = Screen.Width 'max. Width
        .yMax = Screen.Height 'max. Height
    End With
    
    Call Init(Me, RWin)
    
    With cdMedia
        .DialogTitle = "Open Media File"
        .Filter = "*.*"
        .FilterIndex = 0
    End With

    If cPlayer.IsInit = True Then
    
        cPlayer.SetVideoRenderHandle = picMedia.hWnd
        
        If cPlayer.IsMeterInfoSupport = True Then
            'Debug.Print "OK"
        End If
        
        cTimer.Interval = 100
        cTimer.Enabled = True

    End If

End Sub

Private Sub Form_Resize()

    Dim tRect As RECT
    Dim tNormalizedRect As MFVideoNormalizedRect

    If Me.WindowState <> vbMinimized Then

        If Me.ScaleHeight - 66 > 0 Then

            picMedia.Visible = True
            picMedia.Move 0, 0, Me.ScaleWidth, Me.ScaleHeight - 66

        Else

            picMedia.Visible = False

        End If

        lblCurPosition.Move 5, picMedia.Height + 5

        lblDuration.Move Me.ScaleWidth - lblDuration.Width - 5, picMedia.Height + 5

        picSeek.Move lblCurPosition.Left + lblCurPosition.Width + 5, _
            lblCurPosition.Top + (lblCurPosition.Height \ 2) - (picSeek.Height \ _
            2), lblDuration.Left - lblDuration.Width - 15

        cmdPlay.Move 0, lblCurPosition.Top + lblCurPosition.Height
        cmdPause.Move cmdPlay.Left + cmdPlay.Width - 10, cmdPlay.Top
        cmdStop.Move cmdPause.Left + cmdPause.Width - 10, cmdPlay.Top
        cmdMute.Move Me.ScaleWidth - cmdMute.Width, cmdPlay.Top
        picVolume.Move Me.ScaleWidth - cmdMute.Width - 100, cmdPlay.Top + 6, 100, 35
        lblVolume.Move Me.ScaleWidth - cmdMute.Width - picVolume.Width + 5, cmdPlay.Top + 10

        If Not cPlayer Is Nothing Then

            If cPlayer.IsInit = True Then

                If cPlayer.IsMediaReady Then

                    If cPlayer.HasVideo = True Then

                        With tRect

                            .Left = 0
                            .Top = 0
                            .Right = picMedia.ScaleWidth
                            .Bottom = picMedia.ScaleHeight

                        End With

                        With tNormalizedRect

                            .Left = 0
                            .Top = 0
                            .Right = 1
                            .Bottom = 1

                        End With

                        Call cPlayer.SetVideoPos(tNormalizedRect, tRect)

                    End If

                End If

            End If

        End If

    End If

End Sub

Private Sub Form_Unload(Cancel As Integer)

    Call Unhook

    cPlayer.StopMedia

    Call cPlayer.Delay(0.1)

    cTimer.Interval = 0
    cTimer.Enabled = False
    
    Set cTimer = Nothing
    Set cPlayer = Nothing

End Sub

Private Sub CreateRoundRectButton(ByVal oButton As CommandButton, ByVal OnBitmap As Long, ByVal OffBitmap As Long)
    
    Dim hRegion As Long
    
    oButton.Picture = LoadResPicture(OnBitmap, vbResBitmap)
    oButton.DisabledPicture = LoadResPicture(OffBitmap, vbResBitmap)
    oButton.MaskColor = RGB(255, 0, 255)
    oButton.Enabled = False

    hRegion = CreateRoundRectRgn(5, 5, oButton.Width - 5, _
        oButton.Height - 5, 5, 5)

    Call SetWindowRgn(oButton.hWnd, hRegion, True)
    
    Call DeleteObject(hRegion)
End Sub

Private Sub CreateVolumeCtrl(ByVal oPicBox As PictureBox)

    Dim hRegion As Long
    Dim tPA(2) As POINTAPI

    oPicBox.ScaleMode = vbPixels
    
    With tPA(0)
        .x = 0
        .y = oPicBox.ScaleHeight
    End With
    
    With tPA(1)
        .x = oPicBox.ScaleWidth
        .y = 0
    End With
    
    With tPA(2)
        .x = oPicBox.ScaleWidth
        .y = oPicBox.ScaleHeight
    End With
    
    hRegion = CreatePolygonRgn(VarPtr(tPA(0)), 3, WINDING)
    
    Call SetWindowRgn(oPicBox.hWnd, hRegion, True)
    
    Call DeleteObject(hRegion)
    
    oPicBox.Cls
    oPicBox.Scale (0, 0)-(100, 1)
    
    

End Sub

Private Sub mnuFileOpen_Click()

    cdMedia.ShowOpen

    If Len(cdMedia.FileName) > 0& Then
    
        If cPlayer.IsInit = True Then
        
            cPlayer.MediaFile = cdMedia.FileName
        
        End If

    End If

End Sub

Private Sub picVolume_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    Call picVolume_MouseMove(Button, Shift, x, y)
End Sub

Private Sub picVolume_MouseMove(Button As Integer, Shift As Integer, x As Single, _
    y As Single)

    If Button = vbLeftButton Then
        If cPlayer.IsInit = True Then
            If cPlayer.HasAudio = True Then
                If cPlayer.IsAudioVolumeSupport = True Then

                    Call cPlayer.SetAudioMasterVolume(x / 100)

                End If

            End If

        End If
    End If

End Sub


