VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMFPlayer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

'https://www.magnumdb.com

' ----==== Const ====----
Private Const S_OK As Long = &H0&
Private Const S_FALSE As Long = &H1&
Private Const API_TRUE As Long = &H1&
Private Const API_FALSE As Long = &H0&
Private Const MFSTARTUP_FULL As Long = &H0&
Private Const MF_VERSION As Long = &H1&
Private Const GdiPlusVersion As Long = &H1&
Private Const Channels As Long = 2              ' Stereo
Private Const BitsPerSample As Long = 16        ' 16bit
Private Const SamplesPerSecond As Long = 44100  ' 44.1kHz
Private Const Duration As Double = 0.5          ' 0.5 Sekunden
Private Const WH_Riff As Long = 1179011410      ' "RIFF"
Private Const WH_Typ As Long = 1163280727       ' "WAVE"
Private Const WH_Fmt As Long = 544501094        ' "fmt "
Private Const WH_Data As Long = 1635017060      ' "DATA"
Private Const WAVE_FORMAT_PCM As Integer = 1    ' PCM
Private Const SND_MEMORY As Long = &H4          ' Wave aus dem Speicher abspielen
Private Const SND_ASYNC As Long = &H1           ' Asynchron abspielen
Private Const CLSCTX_INPROC As Long = &H1&
Private Const CC_STDCALL As Long = &H4&
Private Const CLSCTX_INPROC_SERVER As Long = &H1&
Private Const CLSCTX_INPROC_HANDLER As Long = &H2&
Private Const CLSCTX_LOCAL_SERVER As Long = &H4&
Private Const CLSCTX_REMOTE_SERVER As Long = &H10&

Private Const CLSCTX_ALL As Long = CLSCTX_INPROC_SERVER Or _
                                   CLSCTX_INPROC_HANDLER Or _
                                   CLSCTX_LOCAL_SERVER Or _
                                   CLSCTX_REMOTE_SERVER

Private Const GUID_NULL As String = "{00000000-0000-0000-0000-000000000000}"
Private Const CLSID_MMDeviceEnumerator As String = "{BCDE0395-E52F-467C-8E3D-C4579291692E}"
Private Const IID_Release As Long = &H8&
Private Const IID_IPicture As String = "{7BF80980-BF32-101A-8BBB-00AA00300CAB}"
Private Const IID_IPropertyStore As String = "{886D8EEB-8CF2-4446-8D02-CDBA1DBDCF99}"
Private Const IID_IPropertyDescription As String = "{6F79D558-3E96-4549-A1D1-7D75D2288814}"
Private Const IID_ISimpleAudioVolume As String = "{87CE5498-68D6-44E5-9215-6DA47EF883D8}"
Private Const IID_IMMDeviceEnumerator As String = "{A95664D2-9614-4F35-A746-DE8DB63617E6}"
Private Const IID_IAudioSessionManager2 As String = "{77AA99A0-1BD6-484F-8BC7-2C654C9A9B6F}"
Private Const IID_IAudioSessionControl2 As String = "{BFB7FF88-7239-4FC9-8FA2-07C950BE9C6D}"
Private Const IID_IAudioMeterInformation As String = "{C02216F6-8C67-4B5B-9D00-D008E73E0064}"
Private Const IID_IMFClock As String = "{2EB1E945-18B8-4139-9B1A-D5D584818530}"
Private Const IID_IMFTopology As String = "{83CF873A-F6DA-4BC8-823F-BACFD55DC433}"
Private Const IID_IMFMetadata As String = "{F88CFB8C-EF16-4991-B450-CB8C69E51704}"
Private Const IID_IMFRateControl As String = "{88DDCD21-03C3-4275-91ED-55EE3929328F}"
Private Const IID_IMFRateSupport As String = "{0A9CCDBC-D797-4563-9667-94EC5D79292D}"
Private Const IID_IMFMediaSource As String = "{279A808D-AEC7-40C8-9C6B-A6B492C78A66}"
Private Const IID_IMFTopologyNode As String = "{83CF873A-F6DA-4BC8-823F-BACFD55DC430}"
Private Const IID_IMFMediaSession As String = "{90377834-21D0-4DEE-8214-BA2E3E6C1127}"
Private Const IID_IMFVideoProcessor As String = "{6ab0000c-fece-4d1f-a2ac-a9573530656e}"
Private Const IID_IMFSourceResolver As String = "{FBE5A32D-A497-4b61-BB85-97B1A848A6E3}"
Private Const IID_IMFVideoMixerBitmap As String = "{814c7b20-0fdb-4eec-af8f-f957c8f69edc}"
Private Const IID_IMFMetadataProvider As String = "{56181D2D-E221-4adb-B1C8-3CEE6A53F76F}"
Private Const IID_IMFStreamDescriptor As String = "{56C03D9C-9DBB-45F5-AB4B-D80F47C05938}"
Private Const IID_IMFMediaTypeHandler As String = "{E93DCF6C-4B07-4E1E-8123-AA16ED6EADF5}"
Private Const IID_IMFSimpleAudioVolume As String = "{089EDF13-CF71-4338-8D13-9E569DBDC319}"
Private Const IID_IMFAudioStreamVolume As String = "{76B1BBDB-4EC8-4F36-B106-70A9316DF593}"
Private Const IID_IMFVideoDisplayControl As String = "{a490b1e4-ab84-4d31-a1b2-181e03b1077a}"
Private Const IID_IMFPresentationDescriptor As String = "{03CB2711-24D7-4DB6-A17F-F3A7A479A536}"

Private Const MFMediaType_Audio As String = "{73647561-0000-0010-8000-00AA00389B71}"
Private Const MFMediaType_Video As String = "{73646976-0000-0010-8000-00AA00389B71}"
Private Const MF_TOPONODE_SOURCE As String = "{835C58EC-E075-4BC7-BCBA-4DE000DF9AE6}"
Private Const MF_TOPONODE_STREAM_DESCRIPTOR As String = "{835C58EE-E075-4BC7-BCBA-4DE000DF9AE6}"
Private Const MF_TOPONODE_PRESENTATION_DESCRIPTOR As String = "{835C58ED-E075-4BC7-BCBA-4DE000DF9AE6}"
Private Const MF_RATE_CONTROL_SERVICE As String = "{866FA297-B802-4BF8-9DC9-5E3B6A9F53C9}"
Private Const MR_POLICY_VOLUME_SERVICE As String = "{1ABAA2AC-9D3B-47C6-AB48-C59506DE784D}"
Private Const MR_STREAM_VOLUME_SERVICE As String = "{F8B5FA2F-32EF-46F5-B172-1321212FB2C4}"
Private Const MR_VIDEO_RENDER_SERVICE As String = "{1092a86c-ab1a-459a-a336-831fbc4d11ff}"
Private Const MR_VIDEO_MIXER_SERVICE As String = "{073cd2fc-6cf4-40b7-8859-e89552c841f8}"
Private Const MF_PROPERTY_HANDLER_SERVICE As String = "{A3FACE02-32B8-41DD-90E7-5FEF7C8991B5}"
Private Const MF_METADATA_PROVIDER_SERVICE As String = "{DB214084-58A4-4D2E-B84F-6F755B2F7A0D}"
Private Const MF_PD_DURATION As String = "{6C990D33-BB8E-477A-8598-0D5D96FCD88A}"
Private Const MF_PD_AUDIO_ENCODING_BITRATE As String = "{6C990D35-BB8E-477A-8598-0D5D96FCD88A}"
Private Const MF_PD_AUDIO_ISVARIABLEBITRATE As String = "{33026EE0-E387-4582-AE0A-34A2AD3BAA18}"
Private Const MF_PD_TOTAL_FILE_SIZE As String = "{6C990D34-BB8E-477A-8598-0D5D96FCD88A}"
Private Const MF_PD_LAST_MODIFIED_TIME As String = "{6C990D38-BB8E-477A-8598-0D5D96FCD88A}"

' ----==== Enums ====----
Private Enum vtb_Interfaces

    'IUnknown
    QueryInterface = 0
    
    'IStream
    Read_Stream = 3
    Seek_Stream = 5
    
    'IMMDevice
    Activate = 3
    GetID = 5
    
    'IAudioSessionEnumerator
    GetCount = 3
    GetSession = 4
    
    'IMMDeviceEnumerator
    GetDefaultAudioEndpoint = 4
    
    'IAudioSessionManager2
    GetSessionEnumerator = 5
    
    'IAudioSessionControl2
    GetProcessId = 14
    
    'IAudioMeterInformation
    GetPeakValue = 3
    GetMeteringChannelCount = 4
    GetChannelsPeakValues = 5
    
    'IMFSourceResolver
    CreateObjectFromURL = 3
    CreateObjectFromByteStream = 4
    BeginCreateObjectFromURL = 5
    EndCreateObjectFromURL = 6
    BeginCreateObjectFromByteStream = 7
    EndCreateObjectFromByteStream = 8
    CancelObjectCreation = 9
    
    'IMFMediaSource
    CreatePresentationDescriptor = 8
    Shutdown_Source = 12
    
    'IMFMediaSession
    SetTopology = 7
    Start_Play = 9
    Pause_Play = 10
    Stop_Play = 11
    Close_Session = 12
    Shutdown_Session = 13
    GetClock = 14
    
    'IMFSimpleAudioVolume
    SetMasterVolume = 3
    GetMasterVolume = 4
    SetMute = 5
    GetMute = 6
    
    'IMFAudioStreamVolume
    GetChannelCount = 3
    SetChannelVolume = 4
    GetChannelVolume = 5
    SetAllVolumes = 6
    GetAllVolumes = 7
    
    'IMFTopologyNode
    SetUINT32 = 21
    SetUnknown = 27
    SetObject = 33
    ConnectOutput = 40
    
    'IMFTopology
    AddNode = 34
    
    'IMFMediaTypeHandler
    GetMajorType = 8
    
    'IMFStreamDescriptor
    GetMediaTypeHandler = 34
    
    'IMFPresentationDescriptor
    GetUINT32 = 7
    GetUINT64 = 8
    GetBlobSize = 14
    GetBlob = 15
    GetStreamDescriptorCount = 33
    GetStreamDescriptorByIndex = 34
    
    'IMFRateControl
    SetRate = 3
    GetRate = 4
    
    'IMFRateSupport
    GetSlowestRate = 3
    GetFastestRate = 4
    IsRateSupported = 5
    
    'IMFClock
    GetCorrelatedTime = 4
    GetState = 6
    
    'IMFMetadata
    GetProperty = 7
    GetAllPropertyNames = 9
    
    'IMFMetadataProvider
    GetMFMetadata = 3
        
    'IPropertyStore
    GetCount_PropStore = 3
    GetAt_PropStore = 4
    GetValue_PropStore = 5
    
    'IPropertyDescription
    GetDisplayName = 6
    
    'IMFVideoDisplayControl
    GetNativeVideoSize = 3
    GetIdealVideoSize = 4
    SetVideoPosition = 5
    GetVideoPosition = 6
    SetAspectRatioMode = 7
    GetAspectRatioMode = 8
    SetVideoWindow = 9
    GetVideoWindow = 10
    RepaintVideo = 11
    GetCurrentImage = 12
    SetBorderColor = 13
    GetBorderColor = 14
    SetRenderingPrefs = 15
    GetRenderingPrefs = 16
    SetFullscreen = 17
    GetFullscreen = 18
        
     'IMFVideoProcessor
    GetAvailableVideoProcessorModes = 3
    GetVideoProcessorCaps = 4
    GetVideoProcessorMode = 5
    SetVideoProcessorMode = 6
    GetProcAmpRange = 7
    GetProcAmpValues = 8
    SetProcAmpValues = 9
    GetFilteringRange = 10
    GetFilteringValue = 11
    SetFilteringValue = 12
    GetBackgroundColor = 13
    SetBackgroundColor = 14

    'IMFVideoMixerBitmap
    SetAlphaBitmap = 3
    ClearAlphaBitmap = 4
    UpdateAlphaBitmapParameters = 5
    GetAlphaBitmapParameters = 6
  
End Enum

Private Enum VARENUM
    VT_EMPTY = 0  '&H0
    VT_NULL = 1  '&H1
    VT_I2 = 2  '&H2
    VT_I4 = 3  '&H3
    VT_R4 = 4  '&H4
    VT_R8 = 5  '&H5
    VT_CY = 6  '&H6
    VT_DATE = 7  '&H7
    VT_BSTR = 8  '&H8
    VT_DISPATCH = 9  '&H9
    VT_ERROR = 10  '&HA
    VT_BOOL = 11  '&HB
    VT_VARIANT = 12  '&HC
    VT_UNKNOWN = 13  '&HD
    VT_DECIMAL = 14  '&HE
    VT_I1 = 16  '&H10
    VT_UI1 = 17  '&H11
    VT_UI2 = 18  '&H12
    VT_UI4 = 19  '&H13
    VT_I8 = 20  '&H14
    VT_UI8 = 21  '&H15
    VT_INT = 22  '&H16
    VT_UINT = 23  '&H17
    VT_VOID = 24  '&H18
    VT_HRESULT = 25  '&H19
    VT_PTR = 26  '&H1A
    VT_SAFEARRAY = 27  '&H1B
    VT_CARRAY = 28  '&H1C
    VT_USERDEFINED = 29  '&H1D
    VT_LPSTR = 30  '&H1E
    VT_LPWSTR = 31  '&H1F
    VT_RECORD = 36  '&H24
    VT_FILETIME = 64  '&H40
    VT_BLOB = 65  '&H41
    VT_STREAM = 66  '&H42
    VT_STORAGE = 67  '&H43
    VT_STREAMED_OBJECT = 68  '&H44
    VT_STORED_OBJECT = 69  '&H45
    VT_BLOB_OBJECT = 70  '&H46
    VT_CF = 71  '&H47
    VT_CLSID = 72  '&H48
    VT_VECTOR = 4096  '&H1000
    VT_ARRAY = 8192  '&H2000
    VT_BYREF = 16384  '&H4000
    VT_RESERVED = 32768  '&H8000
    VT_ILLEGAL = 65535 '&HFFFF
    VT_ILLEGALMASKED = 4095 '&HFFF
    VT_TYPEMASK = 4095 '&HFFF
End Enum

Private Enum Status
    OK = 0
    GenericError = 1
    InvalidParameter = 2
    OutOfMemory = 3
    ObjectBusy = 4
    InsufficientBuffer = 5
    NotImplemented = 6
    Win32Error = 7
    WrongState = 8
    Aborted = 9
    FileNotFound = 10
    ValueOverflow = 11
    AccessDenied = 12
    UnknownImageFormat = 13
    FontFamilyNotFound = 14
    FontStyleNotFound = 15
    NotTrueTypeFont = 16
    UnsupportedGdiplusVersion = 17
    GdiplusNotInitialized = 18
    PropertyNotFound = 19
    PropertyNotSupported = 20
    ProfileNotFound = 21
End Enum

Private Enum STREAM_SEEK
    STREAM_SEEK_SET = &H0
    STREAM_SEEK_CUR = &H1
    STREAM_SEEK_END = &H2
End Enum

Private Enum PSTIME_FLAGS
    PSTF_UTC = 0
    PSTF_LOCAL = 1
End Enum

Private Enum MF_RESOLUTION_TYPE
    MF_RESOLUTION_MEDIASOURCE = &H1&
    MF_RESOLUTION_BYTESTREAM = &H2&
    MF_RESOLUTION_CONTENT_DOES_NOT_HAVE_TO_MATCH_EXTENSION_OR_MIME_TYPE = &H10&
    MF_RESOLUTION_KEEP_BYTE_STREAM_ALIVE_ON_FAIL = &H20&
    MF_RESOLUTION_READ = &H10000
    MF_RESOLUTION_WRITE = &H20000
End Enum

Private Enum MF_OBJECT_TYPE
    MF_OBJECT_MEDIASOURCE = &H0&
    MF_OBJECT_BYTESTREAM = &H1&
    MF_OBJECT_INVALID = &H2&
End Enum

Private Enum MF_TOPOLOGY_TYPE
    MF_TOPOLOGY_OUTPUT_NODE = &H0&
    MF_TOPOLOGY_SOURCESTREAM_NODE = &H1&
    MF_TOPOLOGY_TRANSFORM_NODE = &H2&
    MF_TOPOLOGY_TEE_NODE = &H3&
End Enum

Private Enum ERole
    eConsole = &H0&
    eMultimedia = &H1&
    eCommunications = &H2&
End Enum

Private Enum EDataFlow
    eRender = &H0&
    eCapture = &H1&
    eAll = &H2&
End Enum

' ----==== Type ====----
Private Type PICTDESC
    cbSizeOfStruct As Long
    PicType As Long
    hgdiObj As Long
    hPalOrXYExt As Long
End Type

Private Type GDIPlusStartupInput
    GdiPlusVersion As Long
    DebugEventCallback As Long
    SuppressBackgroundThread As Long
    SuppressExternalCodecs As Long
End Type

Private Type GdiplusStartupOutput
    NotificationHook As Long
    NotificationUnhook As Long
End Type

Private Type API_VARIANT
    vt As Integer
    wReserved1 As Integer
    wReserved2 As Integer
    wReserved3 As Integer
    vData As Long
    Padding As Long
End Type

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Private Type Wave_Header
    cRIFFHeader As Long
    nRIFFBytes As Long
    cDataTypeID As Long
    cFormatHeader As Long
    nFormatBytes As Long
    nFormatTag As Integer
    nChannels As Integer
    nSamplesPerSec As Long
    nAvgBytesPerSec As Long
    nBlockAlign As Integer
    nBitsPerSample As Integer
    cDataHeader As Long
    nDataBytes As Long
End Type

Private Type Wave_Data
    r As Integer
    L As Integer
End Type

' ----==== Kernel32.dll Deklarationen ====----
Private Declare Sub Sleep Lib "kernel32.dll" ( _
                    ByVal lngMilliseconds As Long)

Private Declare Sub CopyMemory Lib "kernel32.dll" _
                    Alias "RtlMoveMemory" ( _
                    ByRef pTo As Any, _
                    ByRef uFrom As Any, _
                    ByVal lSize As Long)

Private Declare Function lstrlenW Lib "kernel32.dll" ( _
                         ByVal lpString As Long) As Long

Private Declare Function GetCurrentProcessId Lib "kernel32.dll" () As Long

Private Declare Function FileTimeToSystemTime Lib "kernel32.dll" ( _
                         ByRef lpFileTime As FILETIME, _
                         ByRef lpSystemTime As SYSTEMTIME) As Long

' ----==== Shlwapi.dll Deklarationen ====----
Private Declare Function SHCreateMemStream Lib "Shlwapi.dll" ( _
                         ByVal pInit As Long, _
                         ByVal cbInit As Long) As Long

' ----==== Oleaut32.dll Deklarationen ====----
Private Declare Function DispCallFunc Lib "Oleaut32.dll" ( _
                         ByVal pvInstance As Long, _
                         ByVal oVft As Long, _
                         ByVal cc As Long, _
                         ByVal vtReturn As VbVarType, _
                         ByVal cActuals As Long, _
                         ByVal prgvt As Any, _
                         ByVal prgpvarg As Any, _
                         ByRef pvargResult As Variant) As Long

Private Declare Function OleCreatePictureIndirect Lib "Oleaut32.dll" ( _
                         ByRef lpPictDesc As PICTDESC, _
                         ByRef riid As GUID, _
                         ByVal fOwn As Boolean, _
                         ByRef lplpvObj As Object) As Long

' ----==== Ole32 API-Deklarationen ====----
Private Declare Sub CoTaskMemFree Lib "ole32.dll" ( _
                    ByVal hMem As Long)

Private Declare Function CLSIDFromString Lib "ole32.dll" ( _
                         ByVal pstring As Long, _
                         ByRef pCLSID As GUID) As Long

Private Declare Function StringFromGUID Lib "ole32.dll" _
                         Alias "StringFromIID" ( _
                         ByRef pCLSID As GUID, _
                         ByRef lpszProgID As Long) As Long

Private Declare Function CoCreateInstance Lib "ole32.dll" ( _
                         ByVal rclsid As Long, _
                         ByVal pUnkOuter As Long, _
                         ByVal dwClsContext As Long, _
                         ByVal riid As Long, _
                         ByRef ppv As Long) As Long

Private Declare Function PropVariantClear Lib "ole32.dll" ( _
                         ByRef pVar As PROPVARIANT) As Long

' ----==== Propsys.dll Deklarationen ====----
Private Declare Function VariantToPropVariant Lib "propsys.dll" ( _
                         ByRef pVar As Variant, _
                         ByRef ppropvar As PROPVARIANT) As Long

Private Declare Function PropVariantToVariant Lib "propsys.dll" ( _
                         ByRef ppropvar As PROPVARIANT, _
                         ByRef pVar As API_VARIANT) As Long

Private Declare Function PropVariantChangeType Lib "propsys.dll" ( _
                         ByVal ppropvarDest As Long, _
                         ByRef propvarSrc As PROPVARIANT, _
                         ByVal flags As Long, _
                         ByVal vt As VARENUM) As Long

Private Declare Function PropVariantToFileTime Lib "propsys.dll" ( _
                         ByRef ppropvar As PROPVARIANT, _
                         ByVal pstfOut As PSTIME_FLAGS, _
                         ByRef pftOut As FILETIME) As Long

Private Declare Function PSGetPropertyKeyFromName Lib "propsys.dll" ( _
                         ByVal pszName As Long, _
                         ByRef propkey As PROPERTYKEY) As Long

Private Declare Function PSGetNameFromPropertyKey Lib "propsys.dll" ( _
                         ByRef propkey As PROPERTYKEY, _
                         ByRef ppszCanonicalName As Long) As Long

Private Declare Function PSGetPropertyDescription Lib "propsys.dll" ( _
                         ByRef propkey As PROPERTYKEY, _
                         ByRef riid As GUID, _
                         ByRef ppv As Long) As Long

' ----==== Mfplat.dll Deklarationen ====----
Private Declare Function MFStartup Lib "Mfplat.dll" ( _
                         ByVal Version As Long, _
                         ByVal dwFlags As Long) As Long

Private Declare Function MFShutdown Lib "Mfplat.dll" () As Long

Private Declare Function MFCreateSourceResolver Lib "Mfplat.dll" ( _
                         ByRef ppISourceResolver As Long) As Long

' ----==== Mf.dll Deklarationen ====----
Private Declare Function MFCreateMediaSession Lib "Mf.dll" ( _
                         ByVal pConfiguration As Long, _
                         ByRef ppMediaSession As Long) As Long

Private Declare Function MFCreateTopology Lib "Mf.dll" ( _
                         ByRef ppTopo As Long) As Long

Private Declare Function MFCreateTopologyNode Lib "Mf.dll" ( _
                         ByVal NodeType As MF_TOPOLOGY_TYPE, _
                         ByRef ppNode As Long) As Long

Private Declare Function MFCreateAudioRendererActivate Lib "Mf.dll" ( _
                         ByRef ppActivate As Long) As Long

Private Declare Function MFCreateVideoRendererActivate Lib "Mf.dll" ( _
                         ByVal hwndVideo As Long, _
                         ByRef ppActivate As Long) As Long

Private Declare Function MFGetService Lib "Mf.dll" ( _
                         ByVal punkObject As Long, _
                         ByVal guidService As Long, _
                         ByVal riid As Long, _
                         ByRef ppvObject As Long) As Long

' ----==== Gdiplus.dll Deklarationen ====----
Private Declare Function GdiplusShutdown Lib "Gdiplus.dll" ( _
                         ByVal token As Long) As Status

Private Declare Function GdiplusStartup Lib "Gdiplus.dll" ( _
                         ByRef token As Long, _
                         ByRef lpInput As GDIPlusStartupInput, _
                         ByRef lpOutput As GdiplusStartupOutput) As Status

Private Declare Function GdipDisposeImage Lib "Gdiplus.dll" ( _
                         ByVal image As Long) As Status

Private Declare Function GdipCreateBitmapFromStream Lib "Gdiplus.dll" ( _
                         ByVal mStream As Long, _
                         ByRef mBitmap As Long) As Status

Private Declare Function GdipCreateHBITMAPFromBitmap Lib "Gdiplus.dll" ( _
                         ByVal BITMAP As Long, _
                         ByRef hbmReturn As Long, _
                         ByVal Background As Long) As Status

' ----==== Winmm.dll Deklarationen ====----
Private Declare Function PlaySoundData Lib "winmm.dll" _
                         Alias "PlaySoundA" ( _
                         ByVal lpData As Long, _
                         ByVal hModule As Long, _
                         ByVal dwFlags As Long) As Long

' ----==== Gdi32.dll Deklarationen ====----
Private Declare Function CreateCompatibleDC Lib "gdi32.dll" ( _
                         ByVal hdc As Long) As Long

Private Declare Function SelectObject Lib "gdi32.dll" ( _
                         ByVal hdc As Long, _
                         ByVal hObject As Long) As Long

Private Declare Function DeleteDC Lib "gdi32.dll" ( _
                         ByVal hdc As Long) As Long

Private Declare Function GetObject Lib "gdi32.dll" _
                         Alias "GetObjectA" ( _
                         ByVal hObject As Long, _
                         ByVal nCount As Long, _
                         ByRef lpObject As Any) As Long

' ----==== User32.dll Deklarationen ====----
Private Declare Function GetDC Lib "user32.dll" ( _
                         ByVal hWnd As Long) As Long

Private Declare Function SetRect Lib "user32.dll" ( _
                         ByRef lpRect As RECT, _
                         ByVal X1 As Long, _
                         ByVal Y1 As Long, _
                         ByVal X2 As Long, _
                         ByVal Y2 As Long) As Long

Private Declare Function ReleaseDC Lib "user32.dll" ( _
                         ByVal hWnd As Long, _
                         ByVal hdc As Long) As Long

' ----==== Variablen ====----
Private m_pIMMDevice As Long
Private m_pISimpleAudioVolume As Long
Private m_pIMMDeviceEnumerator As Long
Private m_pIAudioSessionControl As Long
Private m_pIAudioSessionControl2 As Long
Private m_pIAudioSessionManager2 As Long
Private m_pIAudioMeterInformation As Long
Private m_pIAudioSessionEnumerator As Long

Private m_pIMFClock As Long
Private m_pIMFActivate As Long
Private m_pIMFTopology As Long
Private m_pIMFMetadata As Long
Private m_pIMFMediaSource As Long
Private m_pIMFRateControl As Long
Private m_pIMFRateSupport As Long
Private m_pIPropertyStore As Long
Private m_pIMFMediaSession As Long
Private m_pIMFVideoProcessor As Long
Private m_pIMFMediaTypeHandler As Long
Private m_pIMFStreamDescriptor As Long
Private m_pIMFMetadataProvider As Long
Private m_pIMFVideoMixerBitmap As Long
Private m_pIMFAudioStreamVolume As Long
Private m_pIMFSimpleAudioVolume As Long
Private m_pIMFTopologyNode_Source As Long
Private m_pIMFTopologyNode_Output As Long
Private m_pIMFVideoDisplayControl As Long
Private m_pIMFPresentationDescriptor As Long

Private m_bolInit As Boolean
Private m_bolHasAudio As Boolean
Private m_bolHasVideo As Boolean
Private m_bolMediaReady As Boolean
Private m_bolRateSupport As Boolean
Private m_bolMetadataSupport As Boolean
Private m_bolPropertySupport As Boolean
Private m_bolMeterInfoSupport As Boolean
Private m_bolVideoRenderSupport As Boolean
Private m_bolAudioVolumeSupport As Boolean
Private m_bolHasPropertyPicture As Boolean
Private m_bolHasMetadataPicture As Boolean
Private m_bolStreamVolumeSupport As Boolean
Private m_bolVideoProcessorSupport As Boolean
Private m_bolVideoMixerBitmapSupport As Boolean

Private m_hWndRender As Long
Private m_strMediaFile As String
Private m_oPropertyPic As StdPicture
Private m_oMetadataPic As StdPicture

' ----==== Public Func and Props ====----
Public Property Get IsInit() As Boolean

    IsInit = m_bolInit

End Property

Public Property Get IsMediaReady() As Boolean

    IsMediaReady = m_bolMediaReady

End Property

Public Property Get HasAudio() As Boolean

    HasAudio = m_bolHasAudio

End Property

Public Property Get HasVideo() As Boolean

    HasVideo = m_bolHasVideo

End Property

Public Property Get HasPropertyPicture() As Boolean

    HasPropertyPicture = m_bolHasPropertyPicture

End Property

Public Property Get GetPropertyPicture() As StdPicture
    
    Set GetPropertyPicture = m_oPropertyPic
    
End Property

Public Property Get HasMetadataPicture() As Boolean

    HasMetadataPicture = m_bolHasMetadataPicture

End Property

Public Property Get GetMetadataPicture() As StdPicture
    
    Set GetMetadataPicture = m_oMetadataPic
    
End Property

Public Property Get IsRateSupport() As Boolean

    IsRateSupport = m_bolRateSupport

End Property

Public Property Get IsAudioVolumeSupport() As Boolean

    IsAudioVolumeSupport = m_bolAudioVolumeSupport

End Property

Public Property Get IsStreamVolumeSupport() As Boolean

    IsStreamVolumeSupport = m_bolStreamVolumeSupport

End Property

Public Property Get IsMeterInfoSupport() As Boolean

    IsMeterInfoSupport = m_bolMeterInfoSupport

End Property

Public Property Get IsMetadataSupport() As Boolean

    IsMetadataSupport = m_bolMetadataSupport

End Property

Public Property Get IsPropertyHandlerSupport() As Boolean

    IsPropertyHandlerSupport = m_bolPropertySupport

End Property

Public Property Get IsVideoRenderSupport() As Boolean

    IsVideoRenderSupport = m_bolVideoRenderSupport

End Property

Public Property Get IsVideoProcessorSupport() As Boolean

    IsVideoProcessorSupport = m_bolVideoProcessorSupport

End Property

Public Property Get IsVideoMixerBitmapSupport() As Boolean

    IsVideoMixerBitmapSupport = m_bolVideoMixerBitmapSupport

End Property

Public Function PlayMedia() As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If m_bolMediaReady = True Then

        If Invoke(m_pIMFMediaSession, Start_Play, _
            VarPtr(Str2Guid(GUID_NULL)), _
            VarPtr(Time2PropVar(0))) = S_OK Then

            bolRet = True

        End If
        
    End If

    PlayMedia = bolRet

End Function

Public Function PauseMedia() As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If m_bolMediaReady = True Then

        If Invoke(m_pIMFMediaSession, Pause_Play) = S_OK Then

            bolRet = True

        End If
        
    End If

    PauseMedia = bolRet

End Function

Public Function StopMedia() As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If m_bolMediaReady = True Then
            
        If Invoke(m_pIMFMediaSession, Stop_Play) = S_OK Then

            bolRet = True

        End If
        
    End If

    StopMedia = bolRet

End Function

Public Property Get GetCurrentState() As MFCLOCK_STATE

    Dim lngState As Long
    Dim eRet As MFCLOCK_STATE

    If m_bolMediaReady = True Then

        If Invoke(m_pIMFClock, GetState, 0&, VarPtr(lngState)) = S_OK Then

            eRet = lngState
    
        End If
    
    End If

    GetCurrentState = eRet

End Property

Public Function SeekMediaToPosition(ByVal curPosition As Currency) As Boolean

    Dim bolRet As Boolean
    
    bolRet = False

    If m_bolMediaReady = True Then

        If Invoke(m_pIMFMediaSession, Start_Play, _
            VarPtr(Str2Guid(GUID_NULL)), _
            VarPtr(Time2PropVar(curPosition))) = S_OK Then
    
            bolRet = True
    
        End If
    
    End If

    SeekMediaToPosition = bolRet

End Function

Public Property Get GetMediaCurrentPosition() As Currency

    Dim curRet As Currency
    Dim curClockTime As Currency
    Dim curSystemTime As Currency

    If m_bolMediaReady = True Then
    
        If Invoke(m_pIMFClock, GetCorrelatedTime, 0&, _
            VarPtr(curClockTime), _
            VarPtr(curSystemTime)) = S_OK Then

            curRet = curClockTime * 10000

        End If
    
    End If
    
    GetMediaCurrentPosition = curRet

End Property

Public Property Get GetMediaDuration() As Currency

    Dim curRet As Currency
    Dim curValue As Currency

    If m_bolMediaReady = True Then

        If Invoke(m_pIMFPresentationDescriptor, GetUINT64, _
            VarPtr(Str2Guid(MF_PD_DURATION)), _
            VarPtr(curValue)) = S_OK Then

            curRet = curValue * 10000
            
        End If

    End If

    GetMediaDuration = curRet

End Property

Public Property Get GetMediaFileSize() As Currency

    Dim curRet As Currency
    Dim curValue As Currency

    If m_bolMediaReady = True Then

        If Invoke(m_pIMFPresentationDescriptor, GetUINT64, _
            VarPtr(Str2Guid(MF_PD_TOTAL_FILE_SIZE)), _
            VarPtr(curValue)) = S_OK Then

            curRet = curValue * 10000
            
        End If

    End If

    GetMediaFileSize = curRet

End Property

Public Function GetMediaLastModifiedTime(Optional ByVal strDateFormat As String = _
    "dd/mm/yyyy", Optional ByVal strTimeFormat As String = "hh:mm:ss") As String

    Dim lngBuffSize As Long
    Dim lngBlobSize As Long
    Dim bytBlobData() As Byte
    Dim strDate As String
    Dim strTime As String
    Dim tFILETIME As FILETIME
    Dim tSYSTEMTIME As SYSTEMTIME

    If m_bolMediaReady = True Then

        If Invoke(m_pIMFPresentationDescriptor, GetBlobSize, _
            VarPtr(Str2Guid(MF_PD_LAST_MODIFIED_TIME)), _
            VarPtr(lngBlobSize)) = S_OK Then

            If lngBlobSize > 0& Then

                lngBuffSize = lngBlobSize
                ReDim bytBlobData(lngBlobSize - 1)

                If Invoke(m_pIMFPresentationDescriptor, GetBlob, _
                    VarPtr(Str2Guid(MF_PD_LAST_MODIFIED_TIME)), _
                    VarPtr(bytBlobData(0)), lngBuffSize, _
                    VarPtr(lngBlobSize)) = S_OK Then

                    Call CopyMemory(tFILETIME, bytBlobData(0), LenB(tFILETIME))

                    If FileTimeToSystemTime(tFILETIME, tSYSTEMTIME) = API_TRUE Then

                        strDate = Format$(DateSerial(tSYSTEMTIME.wYear, _
                            tSYSTEMTIME.wMonth, tSYSTEMTIME.wDay), strDateFormat)

                        strTime = Format$(TimeSerial(tSYSTEMTIME.wHour, _
                            tSYSTEMTIME.wMinute, tSYSTEMTIME.wSecond), strTimeFormat)

                    End If
                    
                End If

            End If

        End If

    End If

    GetMediaLastModifiedTime = strDate & " " & strTime

End Function

Public Property Get GetMediaAudioEncodingBitrate() As Long

    Dim lngRet As Long
    Dim lngValue As Long

    If m_bolMediaReady = True Then

        If Invoke(m_pIMFPresentationDescriptor, GetUINT32, _
            VarPtr(Str2Guid(MF_PD_AUDIO_ENCODING_BITRATE)), _
            VarPtr(lngValue)) = S_OK Then

            lngRet = lngValue
            
        End If

    End If

    GetMediaAudioEncodingBitrate = lngRet

End Property

Public Property Get GetMediaAudioIsVariableBitrate() As Boolean

    Dim bolRet As Boolean
    Dim lngValue As Long

    If m_bolMediaReady = True Then

        If Invoke(m_pIMFPresentationDescriptor, GetUINT32, _
            VarPtr(Str2Guid(MF_PD_AUDIO_ISVARIABLEBITRATE)), _
            VarPtr(lngValue)) = S_OK Then

            bolRet = CBool(lngValue)
            
        End If

    End If

    GetMediaAudioIsVariableBitrate = bolRet

End Property

Public Property Let MediaFile(ByVal sMediaFile As String)

    m_strMediaFile = sMediaFile
    
    If m_bolInit = True Then
    
        m_bolHasAudio = False
        m_bolHasVideo = False
        m_bolMediaReady = False
        m_bolRateSupport = False
        m_bolMetadataSupport = False
        m_bolPropertySupport = False
        m_bolMeterInfoSupport = False
        m_bolVideoRenderSupport = False
        m_bolAudioVolumeSupport = False
        m_bolHasPropertyPicture = False
        m_bolHasMetadataPicture = False
        m_bolStreamVolumeSupport = False
        m_bolVideoProcessorSupport = False
        m_bolVideoMixerBitmapSupport = False
        
        Set m_oPropertyPic = Nothing
        Set m_oMetadataPic = Nothing
        
        If NewMediaFile(m_strMediaFile) = True Then
    
            m_bolMediaReady = True
    
        End If
    
    End If

End Property

Public Property Get MediaFile() As String

    MediaFile = m_strMediaFile

End Property

Public Property Let SetVideoRenderHandle(ByVal hWndRender As Long)

    m_hWndRender = hWndRender

End Property


' ----==== Metadata ====----
'
Public Function GetMediaMetadataProperty(ByVal strPropertyName As String) As String

    Dim strRet As String
    Dim tPROPVARIANT As PROPVARIANT

    If m_bolMetadataSupport = True Then

        If Invoke(m_pIMFMetadata, GetProperty, StrPtr(strPropertyName), _
            VarPtr(tPROPVARIANT)) = S_OK Then

            strRet = PropVar2Str(tPROPVARIANT, strPropertyName)

        End If

    End If

    GetMediaMetadataProperty = strRet

End Function

Public Function GetMediaAllMetadataPropertyNames() As String()

    Dim strRet() As String
    Dim tPROPVARIANT As PROPVARIANT

    If m_bolMetadataSupport = True Then

        If Invoke(m_pIMFMetadata, GetAllPropertyNames, _
            VarPtr(tPROPVARIANT)) = S_OK Then

            strRet = Split(PropVar2Str(tPROPVARIANT), ";")

        End If

    End If

    GetMediaAllMetadataPropertyNames = strRet

End Function
'
' ----==== Metadata ====----



' ----==== PropertyStore ====----
'
Public Function GetMediaPropertyCount() As Long

    Dim lngRet As Long
    Dim lngProps As Long

    If m_bolPropertySupport = True Then

        If Invoke(m_pIPropertyStore, GetCount_PropStore, _
            VarPtr(lngProps)) = S_OK Then

            lngRet = lngProps

        End If
    End If

    GetMediaPropertyCount = lngRet

End Function

Friend Function GetMediaPropertyAt(ByVal lngPropIndex As Long) As PROPERTYKEY

    Dim tRet As PROPERTYKEY
    Dim tPROPERTYKEY As PROPERTYKEY

    If m_bolPropertySupport = True Then

        If Invoke(m_pIPropertyStore, GetAt_PropStore, _
            lngPropIndex, VarPtr(tPROPERTYKEY)) = S_OK Then

            tRet = tPROPERTYKEY

        End If
    
    End If

    GetMediaPropertyAt = tRet

End Function

Friend Function GetMediaPropertyValue(ByRef tPropKey As PROPERTYKEY) As PROPVARIANT

    Dim tRet As PROPVARIANT
    Dim tPROPVARIANT As PROPVARIANT
    
    If m_bolPropertySupport = True Then
    
        If Invoke(m_pIPropertyStore, GetValue_PropStore, _
            VarPtr(tPropKey), VarPtr(tPROPVARIANT)) = S_OK Then

            tRet = tPROPVARIANT

        End If
    
    End If

    GetMediaPropertyValue = tRet

End Function
'
' ----==== PropertyStore ====----


' ----==== VideoMixerBitmap ====----
'
Friend Function GetVideoAlphaBitmapParameters() As MFVideoAlphaBitmapParams
    
    Dim tRet As MFVideoAlphaBitmapParams
    Dim tBmpParms As MFVideoAlphaBitmapParams

    If m_bolVideoMixerBitmapSupport = True Then
    
        If Invoke(m_pIMFVideoMixerBitmap, GetAlphaBitmapParameters, _
            VarPtr(tBmpParms)) = S_OK Then
        
            tRet = tBmpParms
        
        End If
    
    End If

    GetVideoAlphaBitmapParameters = tRet
    
End Function

Friend Function SetVideoAlphaBitmapParameters(ByRef tBmpParms As MFVideoAlphaBitmapParams) As Boolean
    
    Dim bolRet As Boolean

    bolRet = False

    If m_bolVideoMixerBitmapSupport = True Then
    
        If Invoke(m_pIMFVideoMixerBitmap, UpdateAlphaBitmapParameters, _
            VarPtr(tBmpParms)) = S_OK Then
        
            bolRet = True
        
        End If
    
    End If

    SetVideoAlphaBitmapParameters = bolRet
    
End Function

Public Function CallVideoClearAlphaBitmap() As Boolean

    Dim bolRet As Boolean

    bolRet = False
    
    If m_bolVideoMixerBitmapSupport = True Then
    
        If Invoke(m_pIMFVideoMixerBitmap, ClearAlphaBitmap) = S_OK Then
        
            bolRet = True
        
        End If
    
    End If

    CallVideoClearAlphaBitmap = bolRet
    
End Function

Friend Function SetVideoAlphaBitmap(ByRef tAlphaBitmap As MFVideoAlphaBitmap) As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If m_bolVideoMixerBitmapSupport = True Then
    
        If Invoke(m_pIMFVideoMixerBitmap, SetAlphaBitmap, _
            VarPtr(tAlphaBitmap)) = S_OK Then
        
            bolRet = True
        
        End If
    
    End If


    SetVideoAlphaBitmap = bolRet
    
End Function

Public Function SetVideoAlphaBitmap2(ByVal bolEnable As Boolean, ByVal hBitmap As _
    Long, ByVal eAlphaBitmapFlags As MFVideoAlphaBitmapFlags, Optional ByVal _
    ptNormalizedRect As Long = 0&, Optional ByVal ptRect As Long = 0&, Optional _
    ByVal sngAlpha As Single = 1!, Optional ByVal lngColorKey As Long = 0&, _
    Optional ByVal eFilterMode As D3DTEXTUREFILTERTYPE = D3DTEXF_POINT) As Boolean

    Dim bolRet As Boolean
    Dim lngHdc As Long
    Dim lngHdcBmp As Long
    Dim lngOldBitmap As Long
    Dim tRect As RECT
    Dim tBitmap As BITMAP
    Dim tMFARGB As MFARGB
    Dim tVideoAlphaBitmap As MFVideoAlphaBitmap
    Dim tNormalizedRect As MFVideoNormalizedRect

    bolRet = False

    If bolEnable = True Then

        If m_hWndRender <> 0& Then

            If hBitmap <> 0& Then

                If ptRect <> 0& Then

                    Call CopyMemory(tRect, ByVal ptRect, LenB(tRect))

                End If

                If ptNormalizedRect <> 0& Then

                    Call CopyMemory(tNormalizedRect, ByVal ptNormalizedRect, _
                        LenB(tNormalizedRect))

                End If

                lngHdc = GetDC(m_hWndRender)

                If lngHdc <> 0& Then

                    lngHdcBmp = CreateCompatibleDC(lngHdc)

                    If lngHdcBmp <> 0& Then

                        lngOldBitmap = SelectObject(lngHdcBmp, hBitmap)

                        If lngOldBitmap <> 0& Then

                            With tVideoAlphaBitmap

                                .GetBitmapFromDC = API_TRUE
                                .HDCOrDDS = lngHdcBmp
                                .Params.dwFlags = eAlphaBitmapFlags
                                .Params.fAlpha = sngAlpha
                                .Params.clrSrcKey = lngColorKey
                                .Params.nrcDest = tNormalizedRect
                                .Params.dwFilterMode = eFilterMode

                            End With

                            If GetObject(hBitmap, Len(tBitmap), tBitmap) <> 0& Then
                            
                                If ptRect <> 0& Then
                                
                                    If CBool(eAlphaBitmapFlags And MFVideoAlphaBitmap_SrcRect) = True Then
                                    
                                        tVideoAlphaBitmap.Params.rcSrc = tRect
                                        
                                    Else
                                    
                                        Call SetRect(tVideoAlphaBitmap.Params.rcSrc, 0&, 0&, _
                                            tBitmap.bmWidth, tBitmap.bmHeight)

                                    End If
                                
                                Else
                                    
                                    Call SetRect(tVideoAlphaBitmap.Params.rcSrc, 0&, 0&, _
                                        tBitmap.bmWidth, tBitmap.bmHeight)
                                    
                                End If
                            

                                bolRet = SetVideoAlphaBitmap(tVideoAlphaBitmap)

                            End If

                            Call SelectObject(lngHdcBmp, lngOldBitmap)

                        End If

                        Call DeleteDC(lngHdcBmp)

                    End If

                    Call ReleaseDC(m_hWndRender, lngHdc)

                End If

            End If

        End If

    Else

        bolRet = CallVideoClearAlphaBitmap

    End If

    SetVideoAlphaBitmap2 = bolRet

End Function
'
' ----==== VideoMixerBitmap ====----



' ----==== VideoProcessor ====----
'
Public Function GetVideoAvailableProcessorModes(ByRef dwNumProcessingModes As _
    Long, ByRef strVideoProcessingModes() As String) As Boolean

    Dim bolRet As Boolean
    Dim lngItem As Long
    Dim tGUID() As GUID
    Dim pVideoProcessingModes As Long

    bolRet = False

    If m_bolVideoProcessorSupport = True Then

        If Invoke(m_pIMFVideoProcessor, GetAvailableVideoProcessorModes, _
            VarPtr(dwNumProcessingModes), VarPtr(pVideoProcessingModes)) = S_OK Then

            ReDim tGUID(dwNumProcessingModes - 1)
            ReDim strVideoProcessingModes(dwNumProcessingModes - 1)

            Call CopyMemory(tGUID(0), ByVal pVideoProcessingModes, _
                LenB(tGUID(0)) * dwNumProcessingModes)

            For lngItem = 0 To dwNumProcessingModes - 1

                strVideoProcessingModes(lngItem) = Guid2Str(tGUID(lngItem))

            Next

            bolRet = True

            Call CoTaskMemFree(pVideoProcessingModes)

        End If

    End If

    GetVideoAvailableProcessorModes = bolRet

End Function

Public Function GetVideoProcessorModeGUID() As String

    Dim strRet As String
    Dim tGUID As GUID

    If m_bolVideoProcessorSupport = True Then

        If Invoke(m_pIMFVideoProcessor, GetVideoProcessorMode, _
            VarPtr(tGUID)) = S_OK Then

            strRet = Guid2Str(tGUID)

        End If

    End If

    GetVideoProcessorModeGUID = strRet

End Function

Public Function SetVideoProcessorModeGUID(ByVal strMode As String) As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If m_bolVideoProcessorSupport = True Then

        If Invoke(m_pIMFVideoProcessor, SetVideoProcessorMode, _
            VarPtr(Str2Guid(strMode))) = S_OK Then

            bolRet = True

        End If

    End If

    SetVideoProcessorModeGUID = bolRet

End Function

Friend Function GetVideoProcessorCapabilities(ByVal strMode As String) As DXVA2_VideoProcessorCaps

    Dim tRet As DXVA2_VideoProcessorCaps
    Dim tVideoProcessorCaps As DXVA2_VideoProcessorCaps

    If m_bolVideoProcessorSupport = True Then

        If Invoke(m_pIMFVideoProcessor, GetVideoProcessorCaps, _
            VarPtr(Str2Guid(strMode)), _
            VarPtr(tVideoProcessorCaps)) = S_OK Then

            tRet = tVideoProcessorCaps

        End If

    End If

    GetVideoProcessorCapabilities = tRet

End Function

Public Function GetVideoBackgroundColor() As Long
    
    Dim lngRet As Long
    Dim lngColor As Long
    
    If m_bolVideoProcessorSupport = True Then
    
        If Invoke(m_pIMFVideoProcessor, GetBackgroundColor, _
            VarPtr(lngColor)) = S_OK Then
    
            lngRet = lngColor
            
        End If
        
    End If
    
    GetVideoBackgroundColor = lngRet
    
End Function

Public Function SetVideoBackgroundColor(ByVal lngColor As Long) As Boolean
    
    Dim bolRet As Boolean
    
    bolRet = False
    
    If m_bolVideoProcessorSupport = True Then
    
        If Invoke(m_pIMFVideoProcessor, SetBackgroundColor, _
            lngColor) = S_OK Then
    
            bolRet = True
            
        End If
        
    End If
    
    SetVideoBackgroundColor = bolRet
    
End Function

Friend Function GetVideoProcAmpRange(ByVal eProcAmpSettings As _
    MFVideoProcAmpSettings) As DXVA2_ValueRange
    
    Dim tRet As DXVA2_ValueRange
    Dim tValueRange As DXVA2_ValueRange
    
    If m_bolVideoProcessorSupport = True Then
    
        If Invoke(m_pIMFVideoProcessor, GetProcAmpRange, _
            eProcAmpSettings, VarPtr(tValueRange)) = S_OK Then
    
            tRet = tValueRange
            
        End If
        
    End If
    
    GetVideoProcAmpRange = tRet
    
End Function

Friend Function GetVideoProcAmpValues(ByVal eProcAmpSettings As _
    MFVideoProcAmpSettings) As DXVA2_ProcAmpValues
    
    Dim tRet As DXVA2_ProcAmpValues
    Dim tValues As DXVA2_ProcAmpValues
    
    If m_bolVideoProcessorSupport = True Then
    
        If Invoke(m_pIMFVideoProcessor, GetProcAmpValues, _
            eProcAmpSettings, VarPtr(tValues)) = S_OK Then
    
            tRet = tValues
            
        End If
        
    End If
    
    GetVideoProcAmpValues = tRet
    
End Function

Friend Function SetVideoProcAmpValues(ByVal eProcAmpSettings As _
    MFVideoProcAmpSettings, ByRef tValues As DXVA2_ProcAmpValues) As Boolean
    
    Dim bolRet As Boolean
    
    bolRet = False
    
    If m_bolVideoProcessorSupport = True Then
    
        If Invoke(m_pIMFVideoProcessor, SetProcAmpValues, _
            eProcAmpSettings, VarPtr(tValues)) = S_OK Then
    
            bolRet = True
            
        End If
        
    End If
    
    SetVideoProcAmpValues = bolRet
    
End Function

Friend Function GetVideoFilteringRange(ByVal eFilteringSettings As _
    MFVideoFilteringSettings) As DXVA2_ValueRange
    
    Dim tRet As DXVA2_ValueRange
    Dim tValueRange As DXVA2_ValueRange
    
    If m_bolVideoProcessorSupport = True Then
    
        If Invoke(m_pIMFVideoProcessor, GetFilteringRange, _
            eFilteringSettings, VarPtr(tValueRange)) = S_OK Then
    
            tRet = tValueRange
            
        End If
        
    End If
    
    GetVideoFilteringRange = tRet
    
End Function

Friend Function GetVideoFilteringValue(eFilteringSettings As _
    MFVideoFilteringSettings) As DXVA2_Fixed32
    
    Dim tRet As DXVA2_Fixed32
    Dim tValue As DXVA2_Fixed32
    
    If m_bolVideoProcessorSupport = True Then
    
        If Invoke(m_pIMFVideoProcessor, GetFilteringValue, _
            eFilteringSettings, VarPtr(tValue)) = S_OK Then
    
            tRet = tValue
            
        End If
        
    End If
    
    GetVideoFilteringValue = tRet
    
End Function

Friend Function SetVideoFilteringValue(eFilteringSettings As _
    MFVideoFilteringSettings, ByRef tValue As DXVA2_Fixed32) As Boolean
    
    Dim bolRet As Boolean
    
    bolRet = False
    
    If m_bolVideoProcessorSupport = True Then
    
        If Invoke(m_pIMFVideoProcessor, SetFilteringValue, _
            eFilteringSettings, VarPtr(tValue)) = S_OK Then
    
            bolRet = True
            
        End If
        
    End If
    
    SetVideoFilteringValue = bolRet
    
End Function
'
' ----==== VideoProcessor ====----


' ----==== VideoDisplayControl ====----
'
Friend Property Get GetVideoSize() As SIZE

    Dim tRet As SIZE
    Dim tSize As SIZE

    If m_bolVideoRenderSupport = True Then

        If Invoke(m_pIMFVideoDisplayControl, GetNativeVideoSize, _
            VarPtr(tSize), 0&) = S_OK Then

            tRet.cx = tSize.cx
            tRet.cy = tSize.cy

        End If

    End If

    GetVideoSize = tRet

End Property

Friend Property Get GetVideoAspectRatio() As SIZE

    Dim tRet As SIZE
    Dim tSize As SIZE
    
    If m_bolVideoRenderSupport = True Then
    
        If Invoke(m_pIMFVideoDisplayControl, GetNativeVideoSize, _
            0&, VarPtr(tSize)) = S_OK Then
        
            tRet.cx = tSize.cx
            tRet.cy = tSize.cy
        
        End If
    
    End If

    GetVideoAspectRatio = tRet
    
End Property

Friend Property Get GetVideoIdealMinSize() As SIZE

    Dim tRet As SIZE
    Dim tSize As SIZE

    If m_bolVideoRenderSupport = True Then
    
        If Invoke(m_pIMFVideoDisplayControl, GetIdealVideoSize, _
            VarPtr(tSize), 0&) = S_OK Then
        
            tRet.cx = tSize.cx
            tRet.cy = tSize.cy
        
        End If
    
    End If

    GetVideoIdealMinSize = tRet
    
End Property

Friend Property Get GetVideoIdealMaxSize() As SIZE

    Dim tRet As SIZE
    Dim tSize As SIZE

    If m_bolVideoRenderSupport = True Then
    
        If Invoke(m_pIMFVideoDisplayControl, GetIdealVideoSize, _
            0&, VarPtr(tSize)) = S_OK Then
        
            tRet.cx = tSize.cx
            tRet.cy = tSize.cy
        
        End If
    
    End If

    GetVideoIdealMaxSize = tRet
    
End Property

Public Function CallVideoRepaint() As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If m_bolVideoRenderSupport = True Then
    
        If Invoke(m_pIMFVideoDisplayControl, _
            RepaintVideo) = S_OK Then
        
            bolRet = True
            
        End If
        
    End If
    
    CallVideoRepaint = bolRet
    
End Function

Public Function SetVideoBorderColor(ByVal lColor As Long) As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If m_bolVideoRenderSupport = True Then
    
        If Invoke(m_pIMFVideoDisplayControl, SetBorderColor, _
            lColor) = S_OK Then
        
            bolRet = True
            
        End If
        
    End If
    
    SetVideoBorderColor = bolRet
    
End Function

Public Function GetVideoBorderColor() As Long

    Dim lngRet As Long
    Dim lngColor As Long

    If m_bolVideoRenderSupport = True Then
    
        If Invoke(m_pIMFVideoDisplayControl, GetBorderColor, _
            VarPtr(lngColor)) = S_OK Then
        
            lngRet = lngColor
            
        End If
        
    End If
    
    GetVideoBorderColor = lngRet
    
End Function

Public Function ChangeVideoRenderHandle(ByVal hWnd As Long) As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If m_bolVideoRenderSupport = True Then
    
        If Invoke(m_pIMFVideoDisplayControl, SetVideoWindow, _
            hWnd) = S_OK Then
        
            m_hWndRender = hWnd
            bolRet = True
            
        End If
        
    End If
    
    SetVideoRenderHandle = bolRet
    
End Function

Public Function GetVideoRenderHandle() As Long

    Dim lngRet As Long
    Dim lngHwnd As Long

    If m_bolVideoRenderSupport = True Then
    
        If Invoke(m_pIMFVideoDisplayControl, GetVideoWindow, _
            VarPtr(lngHwnd)) = S_OK Then
        
            lngRet = lngHwnd
            
        End If
        
    End If
    
    GetVideoRenderHandle = lngRet
    
End Function

Public Function SetVideoAspectRatioMode(ByVal eAspectRatioMode As _
    MFVideoAspectRatioMode) As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If m_bolVideoRenderSupport = True Then

        If Invoke(m_pIMFVideoDisplayControl, SetAspectRatioMode, _
            eAspectRatioMode) = S_OK Then

            bolRet = True

        End If

    End If

    SetVideoAspectRatioMode = bolRet

End Function

Public Function GetVideoAspectRatioMode() As MFVideoAspectRatioMode

    Dim lngRet As MFVideoAspectRatioMode
    Dim eAspectRatioMode As MFVideoAspectRatioMode

    If m_bolVideoRenderSupport = True Then

        If Invoke(m_pIMFVideoDisplayControl, GetAspectRatioMode, _
            VarPtr(eAspectRatioMode)) = S_OK Then

            lngRet = eAspectRatioMode

        End If

    End If

    GetVideoAspectRatioMode = lngRet

End Function

Public Function SetVideoFullScreen(ByVal bolFullScreen As Boolean) As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If m_bolVideoRenderSupport = True Then

        If Invoke(m_pIMFVideoDisplayControl, SetFullscreen, _
            IIf(bolFullScreen = True, API_TRUE, API_FALSE)) = S_OK Then

            bolRet = True

        End If

    End If

    SetVideoFullScreen = bolRet

End Function

Public Function GetVideoFullScreen() As Boolean

    Dim bolRet As Boolean
    Dim bolFullScreen As Boolean

    If m_bolVideoRenderSupport = True Then

        If Invoke(m_pIMFVideoDisplayControl, GetFullscreen, _
            VarPtr(bolFullScreen)) = S_OK Then

            bolRet = bolFullScreen

        End If

    End If

    GetVideoFullScreen = bolRet

End Function

Public Function SetVideoRenderingPrefs(ByVal eRenderPrefs As MFVideoRenderPrefs) As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If m_bolVideoRenderSupport = True Then

        If Invoke(m_pIMFVideoDisplayControl, SetRenderingPrefs, _
            eRenderPrefs) = S_OK Then

            bolRet = True

        End If

    End If

    SetVideoRenderingPrefs = bolRet

End Function

Public Function GetVideoRenderingPrefs() As MFVideoRenderPrefs

    Dim lngRet As MFVideoRenderPrefs
    Dim eRenderPrefs As MFVideoRenderPrefs

    If m_bolVideoRenderSupport = True Then

        If Invoke(m_pIMFVideoDisplayControl, GetRenderingPrefs, _
            VarPtr(eRenderPrefs)) = S_OK Then

            lngRet = eRenderPrefs

        End If

    End If

    GetVideoRenderingPrefs = lngRet

End Function

Friend Function SetVideoPos(ByRef tNormalizedRect As MFVideoNormalizedRect, _
    ByRef tRect As RECT) As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If m_bolVideoRenderSupport = True Then

        If Invoke(m_pIMFVideoDisplayControl, SetVideoPosition, _
            VarPtr(tNormalizedRect), VarPtr(tRect)) = S_OK Then

            bolRet = True

        End If

    End If

    SetVideoPos = bolRet

End Function

Friend Function GetVideoPos(ByRef tNormalizedRect As MFVideoNormalizedRect, _
    ByRef tRect As RECT) As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If m_bolVideoRenderSupport = True Then

        If Invoke(m_pIMFVideoDisplayControl, GetVideoPosition, _
            VarPtr(tNormalizedRect), VarPtr(tRect)) = S_OK Then

            bolRet = True

        End If

    End If

    GetVideoPos = bolRet

End Function

Friend Function GetVideoCurrentImage(ByRef tBIH As BITMAPINFOHEADER, _
    ByRef bytDibBytes() As Byte, ByRef lngDibBuffSize As Long, _
    ByRef curTimeStamp As Currency) As Boolean

    Dim pbytDibBytes As Long
    Dim bolRet As Boolean

    bolRet = False

    If m_bolVideoRenderSupport = True Then

        tBIH.biSize = Len(tBIH)

        If Invoke(m_pIMFVideoDisplayControl, GetCurrentImage, _
            VarPtr(tBIH), VarPtr(pbytDibBytes), VarPtr(lngDibBuffSize), _
            VarPtr(curTimeStamp)) = S_OK Then

            ReDim bytDibBytes(lngDibBuffSize - 1)

            Call CopyMemory(bytDibBytes(0), ByVal pbytDibBytes, lngDibBuffSize)

            Call CoTaskMemFree(pbytDibBytes)

            curTimeStamp = curTimeStamp * 10000

            bolRet = True

        End If

    End If

    GetVideoCurrentImage = bolRet

End Function
'
' ----==== VideoDisplayControl ====----



' ----==== Playbackrate ====----
'
Public Function GetSlowestPlaybackRate(Optional ByVal eDirection As _
    MFRATE_DIRECTION = MFRATE_FORWARD) As Single

    Dim sngRet As Single
    Dim sngRate As Single

    If m_bolRateSupport = True Then

        If Invoke(m_pIMFRateSupport, GetSlowestRate, eDirection, _
            API_TRUE, VarPtr(sngRate)) = S_OK Then

            sngRet = sngRate

        End If

    End If

    GetSlowestPlaybackRate = sngRet

End Function

Public Function GetFastestPlaybackRate(Optional ByVal eDirection As _
    MFRATE_DIRECTION = MFRATE_FORWARD) As Single

    Dim sngRet As Single
    Dim sngRate As Single

    If m_bolRateSupport = True Then

        If Invoke(m_pIMFRateSupport, GetFastestRate, eDirection, _
            API_TRUE, VarPtr(sngRate)) = S_OK Then

            sngRet = sngRate

        End If

    End If

    GetFastestPlaybackRate = sngRet

End Function

Public Function SetPlaybackRate(ByVal sngRate As Single) As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If m_bolRateSupport = True Then

        If Invoke(m_pIMFRateControl, SetRate, API_FALSE, sngRate) = S_OK Then

            bolRet = True

        End If

    End If

    SetPlaybackRate = bolRet

End Function

Public Function GetPlaybackRate() As Single

    Dim sngRet As Single
    Dim sngRate As Single

    If m_bolRateSupport = True Then

        If Invoke(m_pIMFRateControl, GetRate, API_FALSE, VarPtr(sngRate)) = S_OK Then

            sngRet = sngRate

        End If

    End If

    GetPlaybackRate = sngRet

End Function
'
' ----==== Playbackrate ====----



' ----==== SimpleAudioVolume ====----
'
Public Function SetAudioMasterVolume(ByVal sngVolume As Single) As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If m_bolAudioVolumeSupport = True Then

        If sngVolume < 0! Then sngVolume = 0!
        If sngVolume > 1! Then sngVolume = 1!

        If Invoke(m_pIMFSimpleAudioVolume, SetMasterVolume, sngVolume) = S_OK Then

            bolRet = True

        End If

    End If

    SetAudioMasterVolume = bolRet

End Function

Public Function GetAudioMasterVolume() As Single

    Dim sngRet As Single
    Dim sngVolume As Single

    If m_bolAudioVolumeSupport = True Then

        If Invoke(m_pIMFSimpleAudioVolume, GetMasterVolume, _
            VarPtr(sngVolume)) = S_OK Then

            sngRet = sngVolume

        End If
    End If

    GetAudioMasterVolume = sngRet

End Function

Public Function SetAudioMasterMute(ByVal bolMute As Boolean) As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If m_bolAudioVolumeSupport = True Then

        If Invoke(m_pIMFSimpleAudioVolume, SetMute, _
            IIf(bolMute = True, API_TRUE, API_FALSE)) = S_OK Then

            bolRet = True

        End If

    End If

    SetAudioMasterMute = bolRet

End Function

Public Function GetAudioMasterMute() As Boolean

    Dim bolRet As Boolean
    Dim bolMute As Boolean

    bolRet = False

    If m_bolAudioVolumeSupport = True Then

        If Invoke(m_pIMFSimpleAudioVolume, GetMute, VarPtr(bolMute)) = S_OK Then

            bolRet = bolMute

        End If

    End If

    GetAudioMasterMute = bolRet

End Function
'
' ----==== SimpleAudioVolume ====----



' ----==== AudioStreamVolume ====----
'
Public Function GetStreamChannelCount() As Long

    Dim lngRet As Long
    Dim lngCount As Long

    If m_bolStreamVolumeSupport = True Then

        If Invoke(m_pIMFAudioStreamVolume, GetChannelCount, _
            VarPtr(lngCount)) = S_OK Then

            lngRet = lngCount

        End If

    End If

    GetStreamChannelCount = lngRet

End Function

Public Function SetStreamVolumes(ByVal lngChannelCount As Long, ByRef sngVolume() _
    As Single) As Boolean

    Dim lngItem As Long
    Dim bolRet As Boolean

    bolRet = False

    If m_bolStreamVolumeSupport = True Then

        If lngChannelCount = GetStreamChannelCount Then

            For lngItem = 0 To lngChannelCount - 1

                If sngVolume(lngItem) < 0! Then sngVolume(lngItem) = 0!
                If sngVolume(lngItem) > 1! Then sngVolume(lngItem) = 1!

            Next

            If Invoke(m_pIMFAudioStreamVolume, SetAllVolumes, lngChannelCount, _
                VarPtr(sngVolume(0))) = S_OK Then

                bolRet = True

            End If

        End If

    End If

    SetStreamVolumes = bolRet

End Function

Public Function GetStreamVolumes(ByVal lngChannelCount As Long) As Single()

    Dim bolRet As Boolean
    Dim sngVolume() As Single

    bolRet = False

    If m_bolStreamVolumeSupport = True Then

        If lngChannelCount = GetStreamChannelCount Then

            ReDim sngVolume(lngChannelCount - 1)

            If Invoke(m_pIMFAudioStreamVolume, GetAllVolumes, lngChannelCount, _
                VarPtr(sngVolume(0))) = S_OK Then

                bolRet = True

            End If

        End If

    End If

    GetStreamVolumes = sngVolume

End Function

Public Function GetStreamChannelVolume(ByVal lngChannelIndex As Long) As Single

    Dim lngChannelCount As Long
    Dim sngVolume As Single
    Dim sngRet As Single

    If m_bolStreamVolumeSupport = True Then

        lngChannelCount = GetStreamChannelCount

        If lngChannelCount > 0& Then

            If lngChannelIndex >= 0& Then
                If lngChannelIndex <= lngChannelCount - 1 Then

                    If Invoke(m_pIMFAudioStreamVolume, GetChannelVolume, _
                        lngChannelIndex, VarPtr(sngVolume)) = S_OK Then

                        sngRet = sngVolume

                    End If

                End If

            End If

        End If

    End If

    GetStreamChannelVolume = sngRet

End Function

Public Function SetStreamChannelVolume(ByVal lngChannelIndex As Long, ByVal _
    sngVolume As Single) As Boolean

    Dim lngChannelCount As Long
    Dim bolRet As Boolean

    bolRet = False

    If m_bolStreamVolumeSupport = True Then

        lngChannelCount = GetStreamChannelCount

        If lngChannelCount > 0& Then

            If lngChannelIndex >= 0& Then

                If lngChannelIndex <= lngChannelCount - 1 Then

                    If Invoke(m_pIMFAudioStreamVolume, SetChannelVolume, _
                        lngChannelIndex, sngVolume) = S_OK Then

                        bolRet = True

                    End If

                End If

            End If

        End If

    End If

    SetStreamChannelVolume = bolRet

End Function
'
' ----==== AudioStreamVolume ====----



' ----==== AudioMeterInformation ====----
'
Public Function GetMeterInfoPeakValue() As Single

    Dim sngRet As Single
    Dim sngPeak As Single

    If m_bolMeterInfoSupport = True Then

        If Invoke(m_pIAudioMeterInformation, GetPeakValue, VarPtr(sngPeak)) = S_OK _
            Then

            sngRet = sngPeak

        End If
    End If

    GetMeterInfoPeakValue = sngRet

End Function

Public Function GetMeterInfoChannelCount() As Long

    Dim lngRet As Long
    Dim lngChannelCount As Long

    If m_bolMeterInfoSupport = True Then

        If Invoke(m_pIAudioMeterInformation, GetMeteringChannelCount, VarPtr( _
            lngChannelCount)) = S_OK Then

            lngRet = lngChannelCount

        End If

    End If

    GetMeterInfoChannelCount = lngRet

End Function

Public Function GetMeterInfoChannelPeaks(ByVal lngChannelCount As Long) As Single()

    Dim sngRet() As Single
    Dim sngPeak() As Single

    If m_bolMeterInfoSupport = True Then

        If lngChannelCount = GetMeterInfoChannelCount Then

            ReDim sngPeak(lngChannelCount - 1)

            If Invoke(m_pIAudioMeterInformation, GetChannelsPeakValues, _
                lngChannelCount, VarPtr(sngPeak(0))) = S_OK Then

                sngRet() = sngPeak()

            End If

        End If

    End If

    GetMeterInfoChannelPeaks = sngRet()

End Function
'
' ----==== AudioMeterInformation ====----



' ----==== Class Initialize ====----
'
Private Sub Class_Initialize()
    
    m_bolInit = False
    m_bolMediaReady = False
    m_bolRateSupport = False
    m_bolAudioVolumeSupport = False
    m_bolStreamVolumeSupport = False
    m_bolMeterInfoSupport = False
    m_bolMetadataSupport = False
    m_bolPropertySupport = False
    m_bolVideoRenderSupport = False
    m_bolVideoProcessorSupport = False
    m_bolVideoMixerBitmapSupport = False
    
    If MFStartup(MF_VERSION, MFSTARTUP_FULL) = S_OK Then
        
        m_bolInit = True
        
        If CreateAudioMeterInformation = True Then
            
            m_bolMeterInfoSupport = True
        
        End If
    
    End If

End Sub

' ----==== Class Terminate ====----
'
Private Sub Class_Terminate()

    m_bolInit = False
    m_bolMediaReady = False
    m_bolRateSupport = False
    m_bolAudioVolumeSupport = False
    m_bolStreamVolumeSupport = False
    m_bolMeterInfoSupport = False
    m_bolMetadataSupport = False
    m_bolPropertySupport = False
    m_bolVideoRenderSupport = False
    m_bolVideoProcessorSupport = False
    m_bolVideoMixerBitmapSupport = False

    Call Invoke(m_pIMFMediaSession, Stop_Play)
    Call Invoke(m_pIMFMediaSession, Close_Session)
    Call Invoke(m_pIMFMediaSource, Shutdown_Source)
    Call Invoke(m_pIMFMediaSession, Shutdown_Session)

    Call Release(m_pIMMDevice)
    Call Release(m_pISimpleAudioVolume)
    Call Release(m_pIMMDeviceEnumerator)
    Call Release(m_pIAudioSessionControl)
    Call Release(m_pIAudioSessionControl2)
    Call Release(m_pIAudioSessionManager2)
    Call Release(m_pIAudioMeterInformation)
    Call Release(m_pIAudioSessionEnumerator)
    
    Call Release(m_pIMFClock)
    Call Release(m_pIMFActivate)
    Call Release(m_pIMFMetadata)
    Call Release(m_pIMFTopology)
    Call Release(m_pIMFMediaSource)
    Call Release(m_pIPropertyStore)
    Call Release(m_pIMFRateControl)
    Call Release(m_pIMFRateSupport)
    Call Release(m_pIMFMediaSession)
    Call Release(m_pIMFVideoProcessor)
    Call Release(m_pIMFStreamDescriptor)
    Call Release(m_pIMFMetadataProvider)
    Call Release(m_pIMFMediaTypeHandler)
    Call Release(m_pIMFVideoMixerBitmap)
    Call Release(m_pIMFAudioStreamVolume)
    Call Release(m_pIMFSimpleAudioVolume)
    Call Release(m_pIMFTopologyNode_Output)
    Call Release(m_pIMFTopologyNode_Source)
    Call Release(m_pIMFVideoDisplayControl)
    Call Release(m_pIMFPresentationDescriptor)

    Call MFShutdown

End Sub

Private Function NewMediaFile(ByVal sMediaFile As String) As Boolean

    Dim bolRet As Boolean
    Dim lItem As Long
    Dim lCount As Long
    Dim sPropertyNames() As String
    Dim tPropKey As PROPERTYKEY
    Dim tPropVar As PROPVARIANT

    bolRet = False

    Call Invoke(m_pIMFMediaSession, Stop_Play)
    Call Invoke(m_pIMFMediaSession, Close_Session)
    Call Invoke(m_pIMFMediaSource, Shutdown_Source)
    Call Invoke(m_pIMFMediaSession, Shutdown_Session)
    
    Call Release(m_pIMFActivate)
    Call Release(m_pIMFMetadata)
    Call Release(m_pIMFTopology)
    Call Release(m_pIMFMediaSource)
    Call Release(m_pIPropertyStore)
    Call Release(m_pIMFRateControl)
    Call Release(m_pIMFRateSupport)
    Call Release(m_pIMFMediaSession)
    Call Release(m_pIMFVideoProcessor)
    Call Release(m_pIMFStreamDescriptor)
    Call Release(m_pIMFMetadataProvider)
    Call Release(m_pIMFMediaTypeHandler)
    Call Release(m_pIMFVideoMixerBitmap)
    Call Release(m_pIMFAudioStreamVolume)
    Call Release(m_pIMFSimpleAudioVolume)
    Call Release(m_pIMFTopologyNode_Output)
    Call Release(m_pIMFTopologyNode_Source)
    Call Release(m_pIMFVideoDisplayControl)
    Call Release(m_pIMFPresentationDescriptor)

    If CreateMediaSession = True Then

    If CreateMediaSource(sMediaFile) = True Then

        If CreateTopology = True Then
        
            If CreateRateSupport = True Then
                m_bolRateSupport = True
            End If
        
            If m_bolHasAudio = True Then
        
                If CreateSimpleAudioVolume = True Then
                    m_bolAudioVolumeSupport = True
                End If
        
                If CreateAudioStreamVolume = True Then
                    m_bolStreamVolumeSupport = True
                End If
        
            End If
            
            If m_bolHasVideo = True Then
                
                If CreateVideoDisplayControl = True Then
                    m_bolVideoRenderSupport = True
                End If
                
                If CreateVideoProcessor = True Then
                    m_bolVideoProcessorSupport = True
                End If
                
                If CreateVideoMixerBitmap = True Then
                    m_bolVideoMixerBitmapSupport = True
                End If
                
            End If
            
            If CreateMetadataProviderService = True Then
                m_bolMetadataSupport = True
                
                sPropertyNames = Me.GetMediaAllMetadataPropertyNames
                lCount = UBound(sPropertyNames)

                For lItem = 0 To lCount
                
                    Call Me.GetMediaMetadataProperty(sPropertyNames(lItem))
                    
                Next
                
            End If
            
            If CreatePropertyHandlerService = True Then
                m_bolPropertySupport = True
                
                lCount = Me.GetMediaPropertyCount

                For lItem = 0 To lCount - 1

                    tPropKey = Me.GetMediaPropertyAt(lItem)
                    tPropVar = Me.GetMediaPropertyValue(tPropKey)

                    Call Me.PropVar2Str(tPropVar)

                Next
                
            End If

            bolRet = True

        End If

    End If
    
    End If

    NewMediaFile = bolRet

End Function


' ----==== Main Func ====----
'
Private Function CreateMediaSession() As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If MFCreateMediaSession(0&, m_pIMFMediaSession) = S_OK Then

        If Invoke(m_pIMFMediaSession, GetClock, VarPtr(m_pIMFClock)) = S_OK Then

            bolRet = True

        End If

    End If

    CreateMediaSession = bolRet

End Function

Private Function CreateMediaSource(ByVal sURL As String) As Boolean

    Dim bolRet As Boolean
    Dim pIUnknown As Long
    Dim pIMFSourceResolver As Long
    Dim eMFOT As MF_OBJECT_TYPE

    bolRet = False
    eMFOT = MF_OBJECT_INVALID

    If MFCreateSourceResolver(pIMFSourceResolver) = S_OK Then

        If Invoke(pIMFSourceResolver, CreateObjectFromURL, _
            StrPtr(sURL), MF_RESOLUTION_MEDIASOURCE, 0&, _
            VarPtr(eMFOT), VarPtr(pIUnknown)) = S_OK Then

            If eMFOT = MF_OBJECT_MEDIASOURCE Then

                If Invoke(pIUnknown, QueryInterface, _
                    VarPtr(Str2Guid(IID_IMFMediaSource)), _
                    VarPtr(m_pIMFMediaSource)) = S_OK Then

                    bolRet = True

                End If

            End If

            Call Release(pIUnknown)

        End If

        Call Release(pIMFSourceResolver)

    End If

    CreateMediaSource = bolRet

End Function

Private Function CreateTopology() As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If Invoke(m_pIMFMediaSource, CreatePresentationDescriptor, _
        VarPtr(m_pIMFPresentationDescriptor)) = S_OK Then

        If CreatePlaybackTopology = True Then

            If Invoke(m_pIMFMediaSession, SetTopology, 0&, _
                m_pIMFTopology) = S_OK Then

                bolRet = True

            End If

        End If

    End If

    CreateTopology = bolRet

End Function

Private Function CreatePlaybackTopology() As Boolean

    Dim bolRet As Boolean
    Dim lngItem As Long
    Dim lngDescriptorCount As Long

    bolRet = False

    If MFCreateTopology(m_pIMFTopology) = S_OK Then

        If Invoke(m_pIMFPresentationDescriptor, GetStreamDescriptorCount, _
            VarPtr(lngDescriptorCount)) = S_OK Then

            If lngDescriptorCount > 0& Then

                For lngItem = 0 To lngDescriptorCount - 1

                    bolRet = AddBranchToPartialTopology(lngItem)

                Next

            End If

        End If

    End If

    CreatePlaybackTopology = bolRet

End Function

Private Function AddBranchToPartialTopology(ByVal lngIndex As Long) As Boolean

    Dim bolRet As Boolean
    Dim lngSelected As Long

    bolRet = False

    If Invoke(m_pIMFPresentationDescriptor, GetStreamDescriptorByIndex, lngIndex, _
        VarPtr(lngSelected), VarPtr(m_pIMFStreamDescriptor)) = S_OK Then

        If CBool(lngSelected) = True Then

            If CreateSourceNode = True Then

                If CreateOutputNode = True Then

                    If Invoke(m_pIMFTopology, AddNode, _
                        m_pIMFTopologyNode_Source) = S_OK Then

                        If Invoke(m_pIMFTopology, AddNode, _
                            m_pIMFTopologyNode_Output) = S_OK Then

                            If Invoke(m_pIMFTopologyNode_Source, ConnectOutput, _
                                0&, m_pIMFTopologyNode_Output, 0&) = S_OK Then

                                bolRet = True

                            End If

                        End If

                    End If

                End If

            End If

        End If

    End If

    AddBranchToPartialTopology = bolRet

End Function

Private Function CreateSourceNode() As Boolean

    Dim bolRet As Boolean

    bolRet = False

    If MFCreateTopologyNode(MF_TOPOLOGY_SOURCESTREAM_NODE, _
        m_pIMFTopologyNode_Source) = S_OK Then

        If Invoke(m_pIMFTopologyNode_Source, SetUnknown, _
            VarPtr(Str2Guid(MF_TOPONODE_SOURCE)), _
            m_pIMFMediaSource) = S_OK Then

            If Invoke(m_pIMFTopologyNode_Source, SetUnknown, _
                VarPtr(Str2Guid(MF_TOPONODE_PRESENTATION_DESCRIPTOR)), _
                m_pIMFPresentationDescriptor) = S_OK Then

                If Invoke(m_pIMFTopologyNode_Source, SetUnknown, _
                    VarPtr(Str2Guid(MF_TOPONODE_STREAM_DESCRIPTOR)), _
                    m_pIMFStreamDescriptor) = S_OK Then

                    bolRet = True

                End If

            End If

        End If

    End If

    CreateSourceNode = bolRet

End Function

Private Function CreateOutputNode() As Boolean

    Dim bolRet As Boolean
    Dim tGUID As GUID

    bolRet = False

    If Invoke(m_pIMFStreamDescriptor, GetMediaTypeHandler, _
        VarPtr(m_pIMFMediaTypeHandler)) = S_OK Then

        If Invoke(m_pIMFMediaTypeHandler, GetMajorType, VarPtr(tGUID)) = S_OK Then

            If UCase$(Guid2Str(tGUID)) = UCase$(MFMediaType_Audio) Then

                m_bolHasAudio = True

                If MFCreateAudioRendererActivate(m_pIMFActivate) <> S_OK Then

                    Exit Function
                    
                End If

            ElseIf UCase$(Guid2Str(tGUID)) = UCase$(MFMediaType_Video) Then
            
                m_bolHasVideo = True
            
                If m_hWndRender <> 0& Then

                    If MFCreateVideoRendererActivate(m_hWndRender, m_pIMFActivate) <> S_OK Then
                        
                        Exit Function

                    End If
                
                End If

            End If

            If MFCreateTopologyNode(MF_TOPOLOGY_OUTPUT_NODE, _
                m_pIMFTopologyNode_Output) = S_OK Then

                If Invoke(m_pIMFTopologyNode_Output, SetObject, _
                    m_pIMFActivate) = S_OK Then

                    bolRet = True

                End If

            End If

        End If

    End If

    CreateOutputNode = bolRet

End Function



' ----==== Add Func ====----
'
Private Function CreateVideoMixerBitmap() As Boolean

    Dim lngCount As Long
    Dim lngStatus As Long
    Dim bolRet As Boolean

    bolRet = False
    lngCount = 0&

    Do

        lngStatus = MFGetService(m_pIMFMediaSession, _
            VarPtr(Str2Guid(MR_VIDEO_MIXER_SERVICE)), _
            VarPtr(Str2Guid(IID_IMFVideoMixerBitmap)), _
            m_pIMFVideoMixerBitmap)

        Call Delay(0.01)

        lngCount = lngCount + 1

        ' max 5 Versuche, dann abbrechen
        If lngCount = 5 Then Exit Do

    Loop Until lngStatus = S_OK

    If m_pIMFVideoMixerBitmap <> 0& Then

        bolRet = True

    End If

    CreateVideoMixerBitmap = bolRet

End Function

Private Function CreateVideoDisplayControl() As Boolean

    Dim lngCount As Long
    Dim lngStatus As Long
    Dim bolRet As Boolean

    bolRet = False
    lngCount = 0&

    Do

        lngStatus = MFGetService(m_pIMFMediaSession, _
            VarPtr(Str2Guid(MR_VIDEO_RENDER_SERVICE)), _
            VarPtr(Str2Guid(IID_IMFVideoDisplayControl)), _
            m_pIMFVideoDisplayControl)

        Call Delay(0.01)

        lngCount = lngCount + 1

        ' max 5 Versuche, dann abbrechen
        If lngCount = 5 Then Exit Do

    Loop Until lngStatus = S_OK

    If m_pIMFVideoDisplayControl <> 0& Then

        bolRet = True

    End If

    CreateVideoDisplayControl = bolRet

End Function

Private Function CreateVideoProcessor() As Boolean

    Dim lngCount As Long
    Dim lngStatus As Long
    Dim bolRet As Boolean

    bolRet = False
    lngCount = 0&

    Do

        lngStatus = MFGetService(m_pIMFMediaSession, _
            VarPtr(Str2Guid(MR_VIDEO_MIXER_SERVICE)), _
            VarPtr(Str2Guid(IID_IMFVideoProcessor)), _
            m_pIMFVideoProcessor)

        Call Delay(0.01)

        lngCount = lngCount + 1

        ' max 5 Versuche, dann abbrechen
        If lngCount = 5 Then Exit Do

    Loop Until lngStatus = S_OK

    If m_pIMFVideoProcessor <> 0& Then

        bolRet = True

    End If

    CreateVideoProcessor = bolRet

End Function

Private Function CreateAudioStreamVolume() As Boolean

    Dim lngCount As Long
    Dim lngStatus As Long
    Dim bolRet As Boolean

    bolRet = False
    lngCount = 0&

    Do

        lngStatus = MFGetService(m_pIMFMediaSession, _
            VarPtr(Str2Guid(MR_STREAM_VOLUME_SERVICE)), _
            VarPtr(Str2Guid(IID_IMFAudioStreamVolume)), _
            m_pIMFAudioStreamVolume)

        Call Delay(0.01)

        lngCount = lngCount + 1

        ' max 5 Versuche, dann abbrechen
        If lngCount = 5 Then Exit Do

    Loop Until lngStatus = S_OK

    If m_pIMFAudioStreamVolume <> 0& Then

        bolRet = True

    End If

    CreateAudioStreamVolume = bolRet

End Function

Private Function CreateSimpleAudioVolume() As Boolean

    Dim lngCount As Long
    Dim lngStatus As Long
    Dim bolRet As Boolean

    bolRet = False

    Do

        lngStatus = MFGetService(m_pIMFMediaSession, _
            VarPtr(Str2Guid(MR_POLICY_VOLUME_SERVICE)), _
            VarPtr(Str2Guid(IID_IMFSimpleAudioVolume)), _
            m_pIMFSimpleAudioVolume)

        Call Delay(0.01)

        lngCount = lngCount + 1

        ' max 5 Versuche, dann abbrechen
        If lngCount = 5 Then Exit Do

    Loop Until lngStatus = S_OK

    If m_pIMFSimpleAudioVolume <> 0& Then

        bolRet = True

    End If

    CreateSimpleAudioVolume = bolRet

End Function

Private Function CreateAudioMeterInformation() As Boolean

    Dim bolRet As Boolean
    Dim bytWave() As Byte
    Dim lngPID As Long
    Dim lngCount As Long
    Dim lngIndex As Long
    Dim lngSamples As Long
    Dim lngSessionCount As Long
    Dim tWD() As Wave_Data
    Dim tWH As Wave_Header

    bolRet = False

    ' Anzahl der Sample berechnen
    lngSamples = SamplesPerSecond * Duration
    
    ' WaveHeader mit Daten fllen
    With tWH
        .nDataBytes = lngSamples * Channels * BitsPerSample / 8
        .cRIFFHeader = WH_Riff
        .nRIFFBytes = 36 + .nDataBytes
        .cDataTypeID = WH_Typ
        .cFormatHeader = WH_Fmt
        .nFormatBytes = 16
        .nFormatTag = WAVE_FORMAT_PCM
        .nChannels = Channels
        .nSamplesPerSec = SamplesPerSecond
        .nBlockAlign = Channels * BitsPerSample / 8
        .nAvgBytesPerSec = .nSamplesPerSec * .nBlockAlign
        .nBitsPerSample = BitsPerSample
        .cDataHeader = WH_Data
    End With
        
    ' Arrays dimensionieren
    ReDim tWD(lngSamples - 1)
    ReDim bytWave(LenB(tWH) + tWH.nDataBytes - 1)
    
    ' WaveHeader kopieren
    Call CopyMemory(bytWave(0), tWH, LenB(tWH))
    
    ' Wavedaten hinter dem WaveHeader kopieren
    Call CopyMemory(ByVal VarPtr(bytWave(0)) + LenB(tWH), tWD(0), tWH.nDataBytes)
    
    ' erzeugte Wave abspielen
    If PlaySoundData(VarPtr(bytWave(0)), 0&, SND_MEMORY Or SND_ASYNC) <> 0& Then

        Do

            ' IMMDeviceEnumerator erstellen
            If CreateInterface(m_pIMMDeviceEnumerator, _
                CLSID_MMDeviceEnumerator, IID_IMMDeviceEnumerator) = True Then

                ' DefaultAudioEndpoint fr die Wiedergabe ermitteln -> IMMDevice
                If Invoke(m_pIMMDeviceEnumerator, GetDefaultAudioEndpoint, _
                    EDataFlow.eRender, ERole.eConsole, VarPtr(m_pIMMDevice)) = S_OK Then
                    
                    Dim strRet As String
                    If Invoke(m_pIMMDevice, GetID, StrPtr(strRet)) = S_OK Then
                    
                        Debug.Print strRet
                    
                    End If
                    

                    ' IAudioSessionManager2 erstellen
                    If Invoke(m_pIMMDevice, Activate, VarPtr(Str2Guid(IID_IAudioSessionManager2)), _
                        CLSCTX_ALL, 0&, VarPtr(m_pIAudioSessionManager2)) = S_OK Then

                        ' IAudioSessionEnumerator erstellen
                        If Invoke(m_pIAudioSessionManager2, GetSessionEnumerator, _
                            VarPtr(m_pIAudioSessionEnumerator)) = S_OK Then

                            ' Anzahl der laufenden Audiosessions ermitteln
                            If Invoke(m_pIAudioSessionEnumerator, GetCount, _
                                VarPtr(lngSessionCount)) = S_OK Then

                                ' sind laufende Audiosessions vorhanden
                                If lngSessionCount >= 1 Then

                                    ' alle laufenden Audiosessions durchlaufen
                                    For lngIndex = 0 To lngSessionCount - 1

                                        ' IAudioSessionControl von laufender Audiosession
                                        ' erstellen
                                        If Invoke(m_pIAudioSessionEnumerator, GetSession, _
                                            lngIndex, VarPtr(m_pIAudioSessionControl)) = S_OK Then

                                            ' IAudioSessionControl2 erstellen
                                            If Invoke(m_pIAudioSessionControl, QueryInterface, _
                                                VarPtr(Str2Guid(IID_IAudioSessionControl2)), _
                                                VarPtr(m_pIAudioSessionControl2)) = S_OK Then

                                                ' ProzessID von laufender Audiosession
                                                ' ermitteln
                                                If Invoke(m_pIAudioSessionControl2, GetProcessId, _
                                                    VarPtr(lngPID)) = S_OK Then

                                                    ' ist die ermittelte ProzessID = der
                                                    ' ProzessID dieser Anwendung
                                                    If lngPID = GetCurrentProcessId Then

                                                        ' ISimpleAudioVolume erstellen
                                                        If Invoke(m_pIAudioSessionControl2, QueryInterface, _
                                                            VarPtr(Str2Guid(IID_ISimpleAudioVolume)), _
                                                            VarPtr(m_pISimpleAudioVolume)) = S_OK Then

                                                            ' IAudioMeterInformation
                                                            ' erstellen
                                                            If Invoke(m_pIAudioSessionControl2, QueryInterface, _
                                                                VarPtr(Str2Guid(IID_IAudioMeterInformation)), _
                                                                VarPtr(m_pIAudioMeterInformation)) = S_OK Then

                                                                ' Audiosession fr diese
                                                                ' Anwendung gefunden
                                                                bolRet = True

                                                                ' Schleife verlassen
                                                                Exit For

                                                            End If

                                                        End If

                                                    End If

                                                End If

                                                ' IAudioSessionControl2 freigeben
                                                Call Release(m_pIAudioSessionControl2)

                                            End If

                                            ' IAudioSessionControl freigeben
                                            Call Release(m_pIAudioSessionControl)

                                        End If

                                    Next

                                End If

                            End If

                        End If

                    End If

                End If

            End If

            If bolRet = False Then
                Call Release(m_pIAudioMeterInformation)
                Call Release(m_pISimpleAudioVolume)
                Call Release(m_pIAudioSessionControl2)
                Call Release(m_pIAudioSessionControl)
                Call Release(m_pIAudioSessionEnumerator)
                Call Release(m_pIAudioSessionManager2)
                Call Release(m_pIMMDevice)
                Call Release(m_pIMMDeviceEnumerator)
            End If

            Call Delay(0.01)

            lngCount = lngCount + 1

            ' max 5 Versuche, dann abbrechen
            If lngCount = 5 Then Exit Do

        Loop Until bolRet = True

    End If

    CreateAudioMeterInformation = bolRet

End Function

Private Function CreateRateSupport() As Boolean

    Dim lngCount As Long
    Dim lngStatus As Long
    Dim bolRet As Boolean

    bolRet = False
    lngCount = 0&

    Do

        lngStatus = MFGetService(m_pIMFMediaSession, _
            VarPtr(Str2Guid(MF_RATE_CONTROL_SERVICE)), _
            VarPtr(Str2Guid(IID_IMFRateSupport)), _
            m_pIMFRateSupport)

        Call Delay(0.01)

        lngCount = lngCount + 1
        
        ' max 5 Versuche, dann abbrechen
        If lngCount = 5 Then Exit Do

    Loop Until lngStatus = S_OK

    If m_pIMFRateSupport <> 0& Then

        If Invoke(m_pIMFRateSupport, IsRateSupported, _
            API_TRUE, 0&, 0&) = S_OK Then
        
            lngCount = 0&
        
            Do

                lngStatus = MFGetService(m_pIMFMediaSession, _
                    VarPtr(Str2Guid(MF_RATE_CONTROL_SERVICE)), _
                    VarPtr(Str2Guid(IID_IMFRateControl)), _
                    m_pIMFRateControl)

                Call Delay(0.01)

                lngCount = lngCount + 1
        
                ' max 5 Versuche, dann abbrechen
                If lngCount = 5 Then Exit Do

            Loop Until lngStatus = S_OK

            If m_pIMFRateControl <> 0& Then

                bolRet = True

            End If

        End If

    End If

    CreateRateSupport = bolRet

End Function

Private Function CreateMetadataProviderService() As Boolean

    Dim lngCount As Long
    Dim lngStatus As Long
    Dim bolRet As Boolean

    bolRet = False
    lngCount = 0&

    Do

        lngStatus = MFGetService(m_pIMFMediaSource, _
            VarPtr(Str2Guid(MF_METADATA_PROVIDER_SERVICE)), _
            VarPtr(Str2Guid(IID_IMFMetadataProvider)), _
            m_pIMFMetadataProvider)

        Call Delay(0.01)

        lngCount = lngCount + 1

        ' max 5 Versuche, dann abbrechen
        If lngCount = 5 Then Exit Do

    Loop Until lngStatus = S_OK

    If m_pIMFMetadataProvider <> 0& Then

        If Invoke(m_pIMFMetadataProvider, GetMFMetadata, _
            m_pIMFPresentationDescriptor, 0&, 0&, _
            VarPtr(m_pIMFMetadata)) = S_OK Then

            bolRet = True

        End If

    End If

    CreateMetadataProviderService = bolRet

End Function

Private Function CreatePropertyHandlerService() As Boolean

    Dim lngCount As Long
    Dim lngStatus As Long
    Dim bolRet As Boolean

    bolRet = False
    lngCount = 0&

    Do

        lngStatus = MFGetService(m_pIMFMediaSource, _
            VarPtr(Str2Guid(MF_PROPERTY_HANDLER_SERVICE)), _
            VarPtr(Str2Guid(IID_IPropertyStore)), _
            m_pIPropertyStore)

        Call Delay(0.01)

        lngCount = lngCount + 1
        
        ' max 5 Versuche, dann abbrechen
        If lngCount = 5 Then Exit Do

    Loop Until lngStatus = S_OK

    If m_pIPropertyStore <> 0& Then

        bolRet = True

    End If

    CreatePropertyHandlerService = bolRet

End Function


' ----==== Interface Func ====----
'
' ----==== Create Interface ====----
Private Function CreateInterface(ByRef pInterface As Long, ByVal sCLSID As String, _
    ByVal sIID As String) As Boolean

    Dim bRet As Boolean
    Dim tIID As GUID
    Dim tCLSID As GUID
    Dim psIID As Long
    Dim psCLSID As Long
    Dim ptIID As Long
    Dim ptCLSID As Long

    bRet = False
    
    psCLSID = StrPtr(sCLSID)

    ' CLSID -> GUID
    If CLSIDFromString(psCLSID, tCLSID) = S_OK Then

        psIID = StrPtr(sIID)
        ptCLSID = VarPtr(tCLSID)

        ' IID -> GUID
        If CLSIDFromString(psIID, tIID) = S_OK Then

            ptIID = VarPtr(tIID)

            ' Interface erstellen
            If CoCreateInstance(ptCLSID, 0&, CLSCTX_INPROC, ptIID, pInterface) = S_OK Then

                bRet = True

            End If

        End If

    End If

    CreateInterface = bRet

End Function

' ----==== Call OleInvoke ====----
Private Function Invoke(ByVal pInterface As Long, ByVal vtb As vtb_Interfaces, _
    ParamArray var()) As Variant
    
    If pInterface <> 0& Then
    
        Invoke = OleInvoke(pInterface, vtb, var)
        
    End If
    
End Function

' ----==== Release Interface ====----
Private Sub Release(ByRef pInterface As Long)

    Dim vRet As Variant

    ' ist ein Pointer auf ein Interfac vorhanden
    If pInterface <> 0& Then

        ' Funktion Release des Interfaces aufrufen
        If DispCallFunc(pInterface, IID_Release, CC_STDCALL, vbLong, _
            0&, 0&, 0&, vRet) = S_OK Then

            pInterface = 0&

        End If

    End If

End Sub

' ----==== Call Interface Function ====----
Private Function OleInvoke(ByVal pInterface As Long, ByVal lCmd As Long, _
    ParamArray aParam()) As Variant
    
    Dim lCount As Long
    Dim lItem As Long
    Dim vRet As Variant
    Dim vParam As Variant
    Dim olePtr(10) As Long
    Dim oleTyp(10) As Integer
    Dim polePtr As Long
    Dim poleTyp As Long

    ' wenn ein Pointer auf ein Interface vorhanden ist
    If pInterface <> 0& Then

        ' nur wenn zum Aufruf der Interface-Funktion auch
        ' Parameter vorhanden sind.
        If UBound(aParam) >= 0 Then

            ' ParamArray nach Variant
            vParam = aParam

            ' ist der Variant ein Array
            If IsArray(vParam) Then vParam = vParam(0)

            ' Anzahl der Parameter
            lCount = UBound(vParam)

            ' alle Parameter durchlaufen
            For lItem = 0 To lCount

                ' Typ des Parameter
                oleTyp(lItem) = VarType(vParam(lItem))

                ' Pointer auf den Parameter
                olePtr(lItem) = VarPtr(vParam(lItem))

            Next

        End If

        ' Pointer holen
        poleTyp = VarPtr(oleTyp(0))
        polePtr = VarPtr(olePtr(0))

        ' Funktion des Interfaces aufrufen
        If DispCallFunc(pInterface, lCmd * 4, CC_STDCALL, vbLong, _
            lItem, poleTyp, polePtr, vRet) <> S_OK Then
            
            Debug.Print "Fehler beim Aufrufen der Interface-Funktion!"

        End If

    End If

    OleInvoke = vRet

End Function

' ----==== Helper Func ====----
'
' ----==== String -> GUID ====----
Private Function Str2Guid(ByVal str As String) As GUID

    Dim pstr As Long
    
    pstr = StrPtr(str)
    
    Call CLSIDFromString(pstr, Str2Guid)
    
End Function

' ----==== GUID -> String ====----
Private Function Guid2Str(ByRef tGUID As GUID) As String

    Dim lGuid As Long

    If StringFromGUID(tGUID, lGuid) = S_OK Then

        Guid2Str = Ptr2Str(lGuid)
    
    End If

End Function

' ----==== Pointer -> String ====----
Private Function Ptr2Str(ByVal lpStrPointer As Long) As String

    Dim lLen As Long
    Dim bBuffer() As Byte

    If lpStrPointer = 0 Then Exit Function

    lLen = lstrlenW(lpStrPointer) * 2& - 1&

    If lLen > 0& Then

        ReDim bBuffer(lLen)

        Call CopyMemory(bBuffer(0), ByVal lpStrPointer, lLen)
        
        Call CoTaskMemFree(lpStrPointer)

        Ptr2Str = bBuffer

    End If

End Function

' ----==== Delay ====----
Public Sub Delay(ByVal SecsDelay As Single)

    Dim TimeOut   As Single
    Dim PrevTimer As Single

    PrevTimer = Timer
    TimeOut = PrevTimer + SecsDelay

    Do While PrevTimer < TimeOut

        Call Sleep(1)

        DoEvents

        If Timer < PrevTimer Then TimeOut = TimeOut - 86400

        PrevTimer = Timer

    Loop

End Sub

Private Function Time2PropVar(ByVal curPosition As Currency) As PROPVARIANT

    Dim tRet As PROPVARIANT
    Dim tDblVariant As PROPVARIANT

    If curPosition = 0 Then

        With tRet

            .vt = VARENUM.VT_EMPTY
            .vData = 0&

        End With

        Time2PropVar = tRet

    Else

        If VariantToPropVariant(CVar(CDbl(curPosition)), tDblVariant) = S_OK Then

            If PropVariantChangeType(VarPtr(tRet), tDblVariant, _
                0&, VARENUM.VT_I8) = S_OK Then

                Time2PropVar = tRet

            End If

        End If

    End If

End Function

Public Function Time2String(ByVal curNanoSec As Currency, Optional ByVal _
    strTimeFormat As String = "hh:mm:ss") As String

    On Error Resume Next

    Dim lngHour As Long
    Dim lngMinu As Long
    Dim dblSeco As Double

    dblSeco = CDbl(curNanoSec / 10000000)

    lngHour = dblSeco \ 3600
    dblSeco = dblSeco Mod 3600
    lngMinu = dblSeco \ 60
    dblSeco = dblSeco Mod 60

    Time2String = Format$(TimeSerial(lngHour, lngMinu, dblSeco), strTimeFormat)

End Function

Friend Function DXVA2FixedToFloat(ByRef tFixed32 As DXVA2_Fixed32) As Single

    DXVA2FixedToFloat = CSng(tFixed32.Value) + CSng(tFixed32.Fraction) / &H10000

End Function

Friend Function DXVA2FloatToFixed(ByRef sngFloat As Single) As DXVA2_Fixed32

    Dim tFixed32 As DXVA2_Fixed32

    tFixed32.Fraction = LoWord(sngFloat * &H10000)
    tFixed32.Value = HiWord(sngFloat * &H10000)
    DXVA2FloatToFixed = tFixed32

End Function

Private Function HiWord(lngNumber As Long) As Integer

    HiWord = LongToInt(Int((lngNumber / &H10000)))

End Function

Private Function LoWord(ByVal lngNumber As Long) As Integer

    LoWord = LongToInt(lngNumber And &HFFFF&)

End Function

Private Function LongToInt(ByVal lngNumber As Long) As Integer

    lngNumber = lngNumber And &HFFFF&

    If lngNumber > &H7FFF Then

        LongToInt = lngNumber - &H10000

    Else

        LongToInt = lngNumber

    End If

End Function

Friend Function PropVar2Str(ByRef tPropVar As PROPVARIANT, Optional ByVal _
    strPropertyName As String = vbNullString) As String

    Dim lngItem As Long
    Dim lngCount As Long
    Dim strRet As String
    Dim varRet As Variant
    Dim tFILETIME As FILETIME
    Dim tVARIANT As API_VARIANT

    Select Case tPropVar.vt

    Case VARENUM.VT_EMPTY
    
        strRet = vbNullString

    Case VARENUM.VT_BOOL, VARENUM.VT_BSTR, _
         VARENUM.VT_LPSTR, VARENUM.VT_LPWSTR, _
         VARENUM.VT_INT, VARENUM.VT_UINT, _
         VARENUM.VT_I1, VARENUM.VT_UI1, _
         VARENUM.VT_I2, VARENUM.VT_UI2, _
         VARENUM.VT_I4, VARENUM.VT_UI4, _
         VARENUM.VT_I8, VARENUM.VT_UI8, _
         VARENUM.VT_R4, VARENUM.VT_R8, _
         VARENUM.VT_CLSID

        If PropVariantChangeType(VarPtr(varRet), tPropVar, 0&, VT_BSTR) = S_OK Then

            strRet = CStr(varRet)

        End If

    Case VARENUM.VT_FILETIME

            If PropVariantToFileTime(tPropVar, PSTF_LOCAL, tFILETIME) = S_OK Then

                strRet = StringFromFileTime(tFILETIME)

            End If

    Case VARENUM.VT_BLOB
            
            If PropVariantToVariant(tPropVar, tVARIANT) = S_OK Then
            
                Select Case UCase(strPropertyName)
                
                Case UCase("WM/Picture")
                    
                    m_bolHasMetadataPicture = False
                    Set m_oMetadataPic = GetPictureFromBlob(tVARIANT.vData)
                    
                    If Not m_oMetadataPic Is Nothing Then
                        m_bolHasMetadataPicture = True
                        strRet = "[Picture]"
                    End If
                    
                
                Case Else
                    
                    strRet = GetStringFromIStream(tVARIANT.vData)
                
                End Select
            
                Call Release(tVARIANT.vData)
                
            End If
            
    Case VARENUM.VT_STREAM
        
        m_bolHasPropertyPicture = False
        Set m_oPropertyPic = GetPictureFromIStream(tPropVar.vData)
        
        If Not m_oPropertyPic Is Nothing Then
            m_bolHasPropertyPicture = True
            strRet = "[Picture]"
        End If
    
        Call Release(tPropVar.vData)
    
    Case VARENUM.VT_VECTOR Or VARENUM.VT_LPWSTR
    
        If PropVariantChangeType(VarPtr(varRet), tPropVar, 0&, VT_ARRAY Or VT_BSTR) = S_OK Then

            lngCount = UBound(varRet)
            
            For lngItem = 0 To lngCount

                If lngItem > 0& Then
                    
                    strRet = strRet & ";"
                        
                End If

                strRet = strRet & CStr(varRet(lngItem))

            Next
        
        End If

    Case Else

        'Debug.Print tPropVar.vt
        
        strRet = vbNullString

    End Select

    Call PropVariantClear(tPropVar)

    PropVar2Str = strRet

End Function

Private Function GetStringFromIStream(ByVal pIStream As Long) As String

    Dim strRet As String
    Dim bytData() As Byte
    Dim lngDataSize As Long
    Dim curMove As Currency
    Dim curPosition As Currency

    If Invoke(pIStream, Seek_Stream, curMove, STREAM_SEEK.STREAM_SEEK_END, VarPtr( _
        curPosition)) = S_OK Then

        lngDataSize = CLng(curPosition * 10000)

        ReDim bytData(lngDataSize - 1)

        If Invoke(pIStream, Seek_Stream, curMove, STREAM_SEEK.STREAM_SEEK_SET, _
            VarPtr(curPosition)) = S_OK Then

            If Invoke(pIStream, Read_Stream, VarPtr(bytData(0)), lngDataSize, _
                VarPtr(curPosition)) = S_OK Then

                strRet = Trim$(Replace$(CStr(bytData), vbNullChar, Chr$(32)))

            End If

        End If

    End If

    GetStringFromIStream = strRet

End Function

Private Function GetPictureFromBlob(ByVal pIStream As Long) As StdPicture

    Dim bytData() As Byte
    Dim lngDataSize As Long
    Dim curMove As Currency
    Dim curPosition As Currency
    Dim lngPicSize As Long
    Dim pPicStream As Long

    If Invoke(pIStream, Seek_Stream, curMove, STREAM_SEEK.STREAM_SEEK_END, VarPtr( _
        curPosition)) = S_OK Then

        lngDataSize = CLng(curPosition * 10000)

        ReDim bytData(lngDataSize - 1)

        If Invoke(pIStream, Seek_Stream, curMove, STREAM_SEEK.STREAM_SEEK_SET, _
            VarPtr(curPosition)) = S_OK Then

            If Invoke(pIStream, Read_Stream, VarPtr(bytData(0)), lngDataSize, _
                VarPtr(curPosition)) = S_OK Then

                Call CopyMemory(lngPicSize, bytData(1), 4)

                pPicStream = SHCreateMemStream(VarPtr(bytData(lngDataSize - lngPicSize)), lngPicSize)
                
                Set GetPictureFromBlob = GetPictureFromIStream(pPicStream)
                    
                Call Release(pPicStream)
                
            End If

        End If

    End If

End Function

Private Function GetPictureFromIStream(ByVal pIStream As Long) As StdPicture

    Dim lBitmap As Long
    Dim hBitmap As Long
    Dim lGdipToken As Long
    Dim tPictDesc As PICTDESC
    Dim tGdipStartupInput As GDIPlusStartupInput
    Dim tGdipStartupOutput As GdiplusStartupOutput

    tGdipStartupInput.GdiPlusVersion = GdiPlusVersion

    ' GDI+ starten
    If GdiplusStartup(lGdipToken, tGdipStartupInput, tGdipStartupOutput) = OK Then
        
        ' GDI+ Bitmap vom Stream erstellen
        If GdipCreateBitmapFromStream(pIStream, lBitmap) = OK Then

            ' GDI32 Handle vom GDI+ Bitmap abrufen
            If GdipCreateHBITMAPFromBitmap(lBitmap, hBitmap, 0&) = OK Then

                With tPictDesc

                    .cbSizeOfStruct = Len(tPictDesc)
                    .PicType = PictureTypeConstants.vbPicTypeBitmap
                    .hgdiObj = hBitmap
                    .hPalOrXYExt = 0&

                End With

                ' Bitmap vom Handle erstellen
                If OleCreatePictureIndirect(tPictDesc, Str2Guid(IID_IPicture), _
                    API_FALSE, GetPictureFromIStream) <> S_OK Then

                    Set GetPictureFromIStream = Nothing

                End If

            End If

            ' GDI+ Bitmap lschen
            Call GdipDisposeImage(lBitmap)

        End If

        ' GDI+ beenden
        Call GdiplusShutdown(lGdipToken)

    End If

End Function

Private Function StringFromFileTime(ByRef tFILETIME As FILETIME) As String

    Dim sRet As String
    Dim tSYSTEMTIME As SYSTEMTIME

        If FileTimeToSystemTime(tFILETIME, tSYSTEMTIME) <> 0 Then

            With tSYSTEMTIME

                sRet = Format$(.wDay, "00") & "." & Format$(.wMonth, "00") & _
                    "." & Format$(.wYear, "0000") & " " & Format$(.wHour, "00") & _
                    ":" & Format$(.wMinute, "00") & ":" & Format$(.wSecond, _
                    "00")

            End With

        End If

    StringFromFileTime = sRet

End Function

Friend Function GetCanonicalNameFromPropertyKey(ByRef tPropKey As PROPERTYKEY) As String

    Dim strRet As String
    Dim pCanonicalName As Long

    If PSGetNameFromPropertyKey(tPropKey, pCanonicalName) = S_OK Then

        strRet = Ptr2Str(pCanonicalName)

    End If

    GetCanonicalNameFromPropertyKey = strRet

End Function

Friend Function GetPropertyKeyFromCanonicalName(ByVal strCanonicalName As String) _
    As PROPERTYKEY

    Dim tRet As PROPERTYKEY
    Dim tPROPERTYKEY As PROPERTYKEY

    If PSGetPropertyKeyFromName(StrPtr(strCanonicalName), tPROPERTYKEY) = S_OK Then

        tRet = tPROPERTYKEY

    End If

    GetPropertyKeyFromCanonicalName = tRet

End Function

Friend Function GetPropertyDescriptionFromPropertyKey(ByRef tPropKey As _
    PROPERTYKEY) As String

    Dim strRet As String
    Dim pDisplayName As Long
    Dim pPropertyDescription As Long

    If PSGetPropertyDescription(tPropKey, Str2Guid(IID_IPropertyDescription), _
        pPropertyDescription) = S_OK Then

        If Invoke(pPropertyDescription, GetDisplayName, _
            VarPtr(pDisplayName)) = S_OK Then

            strRet = Ptr2Str(pDisplayName)

        End If

        Call Release(pPropertyDescription)

    End If

    GetPropertyDescriptionFromPropertyKey = strRet

End Function
